//================================================================
// Bookmark Favicon Changer by Sonthakit Leelahanon.
// Copyright 2016 Sonthakit Leelahanon. All rights reserved.
//================================================================

var bookmarkfaviconchangerBrowser = {
	setIcon: null,
	_insertNewItem: null,
	_insertNewItemToPopup: null,
	onload: function() {
		Components.utils.import("chrome://bookmarkfaviconchanger/content/module.jsm");
		bookmarkfaviconchangerModule.init();
		// hook function gBrowser.setIcon so that webpage cannot change favicon back
		// setIcon( aTab, aURI ) - This function is binding in chrome://browser/content/tabbrowser.xml
		bookmarkfaviconchangerBrowser.setIcon = gBrowser.setIcon;
		gBrowser.setIcon = function()
		{
			try {
				var tabCurrentURI = gBrowser.getBrowserForTab(arguments[0]).currentURI;
				var bookmarkURI = bookmarkfaviconchangerModule.bookmarksService.getBookmarkedURIFor(tabCurrentURI);
				if (bookmarkURI==null) {
					// First time when browser start, if there is a redirect URI,
					//      function getBookmarkedURIFor usually cause exception due to no valid history redirect before that.
					//      I just drop it because tabCurrentURI guarantee to be not bookmarked.
					// But sometime getBookmarkedURIFor return null without any reason.
					//      So to recue this situation, I try to using tabCurrentURI instead
					bookmarkURI = tabCurrentURI;
				}
				var originalFaviconURISpec = bookmarkfaviconchangerModule.annotationService.getPageAnnotation(bookmarkURI
					,bookmarkfaviconchangerModule.pageOriginalFaviconURISpecNS);
				// throw exception if no annotation data
				try {
					var faviconURI = bookmarkfaviconchangerModule.annotationService.getPageAnnotation(bookmarkURI,bookmarkfaviconchangerModule.pageFaviconDataURISpecNS);
				} catch(e) {
					// if pageFaviconDataURISpec is invalid (should not happen) (this NS appear in 1.60), I use the old method to protect favicon
					var faviconURI = bookmarkfaviconchangerModule.getFaviconForPage(bookmarkURI);
				}
				arguments[1] = faviconURI;
			} catch(e) {
			}
			bookmarkfaviconchangerBrowser.setIcon.apply(this, arguments);
		};
		// hook function PlacesToolbar.prototype._insertNewItem in browserPlacesViews.js to place unique attribute for button on bookmark toolbar
		// function PT__insertNewItem(aChild, aBefore)
		bookmarkfaviconchangerBrowser._insertNewItem = PlacesToolbar.prototype._insertNewItem;
		PlacesToolbar.prototype._insertNewItem = function()
		{
			bookmarkfaviconchangerBrowser._insertNewItem.apply(this, arguments);
			try {
				if (bookmarkfaviconchangerModule.isUsableItemId(arguments[0].itemId)) {
					if (arguments[1]) {
						var thisElement = arguments[1].previousElementSibling;
					} else {
						var thisElement = this._rootElt.lastElementChild;
					}
					thisElement.setAttribute("bookmarkfaviconchanger",arguments[0].itemId);
				}
			} catch(e) {
			}
		};
		// hook function PlacesViewBase.prototype._insertNewItemToPopup in browserPlacesViews.js to insert unique attribute for menu
		// This function also create dropdown menu of bookmark toolbar
		// element = function PVB__insertNewItemToPopup(aNewChild, aPopup, aBefore)
		bookmarkfaviconchangerBrowser._insertNewItemToPopup = PlacesViewBase.prototype._insertNewItemToPopup;
		PlacesViewBase.prototype._insertNewItemToPopup = function()
		{
			var thisElement = bookmarkfaviconchangerBrowser._insertNewItemToPopup.apply(this, arguments);
			try {
				if (bookmarkfaviconchangerModule.isUsableItemId(arguments[0].itemId)) {
					thisElement.setAttribute("bookmarkfaviconchanger",arguments[0].itemId);
				}
			} catch(e) {
			}
			return thisElement;
		};
		// Make sure that bookmark toolbar buttons had not been created. My hook functions need to load before bookmark toolbar buttons creation.
		// Personal Titlebar v1.0.20110810 use PlacesToolbarHelper to make toolbar button appear too early
		// Bookmark Autohider v0.1.7.9 use setToolbarVisibility() to make toolbar button appear too early and hidden
		// Rebuilding toolbar by use rapid customized toolbar method by call PlacesToolbarHelper.customizeStart(); PlacesToolbarHelper.customizeDone();
		//		work well but default context menu will be disable if bookmark toolbar hidden
		// So, we need to use more basic method by add attribute one by one
		var placesToolbarItems = document.getElementById("PlacesToolbarItems");
		if (placesToolbarItems) {
			var toolbarButton = placesToolbarItems.firstChild;
			while (toolbarButton!=null) {
				try {
					if (bookmarkfaviconchangerModule.isUsableItemId(toolbarButton._placesNode.itemId)) {
						toolbarButton.setAttribute("bookmarkfaviconchanger",toolbarButton._placesNode.itemId);
					}
				} catch(e) {
				}
				toolbarButton = toolbarButton.nextSibling;
			}
		}
		window.removeEventListener("load", function(){bookmarkfaviconchangerBrowser.onload();}, false);
		// window.addEventListener("unload", function(){bookmarkfaviconchangerBrowser.onunload();}, false);
	},
	//onunload: function() {
		// window.removeEventListener("unload", function(){bookmarkfaviconchangerBrowser.onunload();}, false);
	//},
	delayLoadEvent: function() {
		// I add load event at this to make sure that this extension will be run at the last, not before other extension
		// Because some extension use e-v-a-l to destroy my hook function (eg. faviconizetab version 1.0.4)
		// And some extension manipulate the same target as mine. (eg. CuteButtons - Crystal SVG version 0.2.9).
		// Inserting element into context menu is also important.
		// These problem can be solved if this extension run at the last. THE LAST IS THE WINNER! :D
		window.removeEventListener("DOMContentLoaded", bookmarkfaviconchangerBrowser.delayLoadEvent, false);
		window.addEventListener("load", function(){bookmarkfaviconchangerBrowser.onload();}, false);
	},
}
window.addEventListener("DOMContentLoaded", bookmarkfaviconchangerBrowser.delayLoadEvent, false);