//================================================================
// Bookmark Favicon Changer by Sonthakit Leelahanon.
// Copyright 2016 Sonthakit Leelahanon. All rights reserved.
//================================================================

var bookmarkfaviconchangerEditBookmarkOverlay = {
	popupEventListening: false,
	commandEventListening: false,
	_appendFolderItemToMenupopup: null,
	onloadFolderMenuList: function() {
		if (!this.commandEventListening) {
			var folderMenuList = document.getElementById("editBMPanel_folderMenuList");
			if (folderMenuList) {
				this.updateFolderMenuList();
				folderMenuList.addEventListener("command",function(){bookmarkfaviconchangerEditBookmarkOverlay.updateFolderMenuList();}, false);
				this.commandEventListening = true;
			}
		}
	},
	onunloadFolderMenuList: function() {
		if (this.commandEventListening) {
			var folderMenuList = document.getElementById("editBMPanel_folderMenuList");
			folderMenuList.removeEventListener("command",function(){bookmarkfaviconchangerEditBookmarkOverlay.updateFolderMenuList();}, false);
			this.commandEventListening = false;
		}
	},
	popupShown: function(event) {
		if (event.target.id == "editBookmarkPanel") {
			this.onloadFolderMenuList();
		}
	},
	popupHiding: function(event) {
		if (event.target.id == "editBookmarkPanel") {
			this.onunloadFolderMenuList();
		}
	},
	updateFolderMenuList: function(event) {
		var folderMenuList = document.getElementById("editBMPanel_folderMenuList");
		folderMenuList.removeAttribute("bookmarkfaviconchanger");
		var selectedIndex = folderMenuList.selectedIndex;
		if (selectedIndex != -1) {
			var selectedNode = folderMenuList.menupopup.childNodes[selectedIndex];
			if (selectedNode.hasAttribute("bookmarkfaviconchanger")) {
				folderMenuList.setAttribute("bookmarkfaviconchanger",selectedNode.getAttribute("bookmarkfaviconchanger"));
			}
		}
	},
	onload: function() {
		Components.utils.import("chrome://bookmarkfaviconchanger/content/module.jsm");
		bookmarkfaviconchangerModule.init();
		// hook function gEditItemOverlay._appendFolderItemToMenupopup(aMenupopup, aFolderId) --> return the new menu item.
		// This function make dropdown menuitem (show common folder) of editBookmarkOverlay.xul which is dynamic overlay of browser.js
		bookmarkfaviconchangerEditBookmarkOverlay._appendFolderItemToMenupopup = gEditItemOverlay._appendFolderItemToMenupopup;
		gEditItemOverlay._appendFolderItemToMenupopup = function()
		{
			var thisFolderMenuItem = bookmarkfaviconchangerEditBookmarkOverlay._appendFolderItemToMenupopup.apply(this, arguments);
			try {
				if (bookmarkfaviconchangerModule.isUsableItemId(arguments[1])) {
					thisFolderMenuItem.setAttribute("bookmarkfaviconchanger",arguments[1]);
				}
			} catch(e) {
			}
			return thisFolderMenuItem;
		};
		var folderMenuList = document.getElementById("editBMPanel_folderMenuList");
		if (folderMenuList) {
			// If folderMenuList menuitem had already been loaded. We need to associate attribute to it
			var menupopup = folderMenuList.menupopup;
			if (menupopup) {
				for (var i = 0; i < menupopup.childNodes.length; i++) {
					if (bookmarkfaviconchangerModule.isUsableItemId(menupopup.childNodes[i].folderId)) {
						menupopup.childNodes[i].setAttribute("bookmarkfaviconchanger",menupopup.childNodes[i].folderId);
					}
				}
			}
			this.onloadFolderMenuList();
		} else {		// no folderMenuList mean editBookmarkOverlay.xul is dynamic overlay
			var editBookmarkPanel = document.getElementById("editBookmarkPanel");
			if (editBookmarkPanel) {
				editBookmarkPanel.addEventListener("popupshown", function(event){bookmarkfaviconchangerEditBookmarkOverlay.popupShown(event);}, false);
				editBookmarkPanel.addEventListener("popuphiding", function(event){bookmarkfaviconchangerEditBookmarkOverlay.popupHiding(event);}, false);
				this.popupEventListening = true;
			}
		}
		window.removeEventListener("load", function(){bookmarkfaviconchangerEditBookmarkOverlay.onload();}, false);
		window.addEventListener("unload", function(){bookmarkfaviconchangerEditBookmarkOverlay.onunload();}, false);
	},
	onunload: function() {
		this.onunloadFolderMenuList();
		if (this.popupEventListening) {
			var editBookmarkPanel = document.getElementById("editBookmarkPanel");
			editBookmarkPanel.removeEventListener("popupshown", function(event){bookmarkfaviconchangerEditBookmarkOverlay.popupShown(event);}, false);
			editBookmarkPanel.removeEventListener("popuphiding", function(event){bookmarkfaviconchangerEditBookmarkOverlay.popupHiding(event);}, false);
			this.popupEventListening = false;
		}
		window.removeEventListener("unload", function(){bookmarkfaviconchangerEditBookmarkOverlay.onunload();}, false);
	},
	delayLoadEvent: function() {
		// I add load event at this to make sure that this extension will be run at the last, not before other extension
		// Because some extension use e-v-a-l to destroy my hook function (eg. faviconizetab version 1.0.4)
		// And some extension manipulate the same target as mine. (eg. CuteButtons - Crystal SVG version 0.2.9).
		// Inserting element into context menu is also important.
		// These problem can be solved if this extension run at the last. THE LAST IS THE WINNER! :D
		window.removeEventListener("DOMContentLoaded", bookmarkfaviconchangerEditBookmarkOverlay.delayLoadEvent, false);
		window.addEventListener("load", function(){bookmarkfaviconchangerEditBookmarkOverlay.onload();}, false);
	}
}
window.addEventListener("DOMContentLoaded", bookmarkfaviconchangerEditBookmarkOverlay.delayLoadEvent, false);