//================================================================
// Bookmark Favicon Changer by Sonthakit Leelahanon.
// Copyright 2016 Sonthakit Leelahanon. All rights reserved.
//================================================================

var EXPORTED_SYMBOLS = ["bookmarkfaviconchangerModule"];

var bookmarkfaviconchangerModule = {
	styleSheetService: Components.classes["@mozilla.org/content/style-sheet-service;1"].getService(Components.interfaces.nsIStyleSheetService),
	ioService: Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService),
	annotationService: Components.classes["@mozilla.org/browser/annotation-service;1"].getService(Components.interfaces.nsIAnnotationService),
	faviconService: Components.classes["@mozilla.org/browser/favicon-service;1"].getService(Components.interfaces.nsIFaviconService),
	bookmarksService: Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService),
	historyService: Components.classes["@mozilla.org/browser/nav-history-service;1"].getService(Components.interfaces.nsINavHistoryService),
	observerService: Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService),
	promptService: Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService),
	watcherService: Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher),
	runtimeService: Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime),
	mediatorService: Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator),
	atomService: Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService),
	threadService: Components.classes['@mozilla.org/thread-manager;1'].getService(Components.interfaces.nsIThreadManager),
	pageFaviconDataURISpecNS: "bookmarkfaviconchanger/faviconDataURISpec",	 // version >= 1.60 (not use in export and json backup, what you see is what you get policy)
	pageOriginalFaviconURISpecNS: "bookmarkfaviconchanger/faviconurispec",	 // Real NS is inherited, not good meaning, but do no change for forward compatibility
	itemFolderFaviconDataURISpecNS: "bookmarkfaviconchanger/faviconurispec", // Real NS is inherited, not good meaning, but do no change for forward compatibility
	itemJsonFolderFaviconDataURISpecNS: "bookmarkfaviconchanger/folderFaviconDataURISpec",
	itemJsonFaviconDataURISpecNS: "bookmarkfaviconchanger/faviconDataURISpec",
	itemJsonOriginalFaviconURISpecNS: "bookmarkfaviconchanger/originalFaviconURISpec",
	geckoBefore13: false,
	geckoBefore18: false,
	geckoBefore22: false,
	geckoBefore23: false,
	geckoBefore24: false,
	geckoBefore25: false,
	geckoBefore36: false,
	defaultFaviconURI: null,
	defaultFaviconURISpec: null,
	defaultFaviconDataURISpec: null,
	livemarkItemFaviconURI: null,			// this variable is not use in Gecko13+
	livemarkItemFaviconURISpec: null,		// this variable is not use in Gecko13+
	livemarkItemFaviconDataURISpec: null,	// this variable is not use in Gecko13+
	branch: null,
	bundle: null,
	quitApplicationGranted: false,
	beingUninstalled: false,
	beingDisabled: false,
	lockCSS: false,
	myCSSDataURISpec: "",
	saveBookmarksToJSONFile: null,
	saveBookmarksToJSONFileThis: null,
	saveBookmarksToJSONFileArguments: null,
	saveBookmarksToJSONFileBusy: false,
	saveBookmarksToJSONFileReturnValue: null,
	placesActive: false,
	init: function() {
		if (this.branch == null) {		// first import
			this.branch = Components.classes["@mozilla.org/preferences-service;1"]
				.getService(Components.interfaces.nsIPrefService).getBranch("extensions.bookmarkfaviconchanger.");
			var platformVer = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo).platformVersion;
			if (Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo).name=="Pale Moon") {
				platformVer = "25.0";
			}
			var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator);
			if (versionChecker.compare(platformVer,"13") < 0) {
				this.geckoBefore13 = true;
				this.branch.QueryInterface(Components.interfaces.nsIPrefBranch2);		// This function no need in Gecko 13+
			}
			if (versionChecker.compare(platformVer,"18") < 0) {
				this.geckoBefore18 = true;
			}
			if (versionChecker.compare(platformVer,"22") < 0) {
				this.geckoBefore22 = true;
			}
			if (versionChecker.compare(platformVer,"23") < 0) {
				this.geckoBefore23 = true;
			}
			if (versionChecker.compare(platformVer,"24") < 0) {
				this.geckoBefore24 = true;
			}
			if (versionChecker.compare(platformVer,"25") < 0) {
				this.geckoBefore25 = true;
			}
			if (versionChecker.compare(platformVer,"36") < 0) {
				this.geckoBefore36 = true;
			}
			this.bundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService)
				.createBundle("chrome://bookmarkfaviconchanger/locale/locale.properties");
			// create default favicon spec and dataURI
			this.defaultFaviconURI = this.faviconService.defaultFavicon;
			this.defaultFaviconURISpec = this.defaultFaviconURI.spec;
			try {
				this.defaultFaviconDataURISpec = this.getFaviconDataAsDataURL(null, this.defaultFaviconURI);
			} catch(e) {
				try {
					var channel = this.ioService.newChannel(this.defaultFaviconURISpec, 0, null);
					var stream = channel.open();
					var bstream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
					bstream.setInputStream(stream);
					this.defaultFaviconDataURISpec = "data:image/png;base64," + btoa(bstream.readBytes(bstream.available()));
					bstream.close();
				} catch(e) {
					this.defaultFaviconDataURISpec = null;		// should not happen
				}
			}
			if (this.geckoBefore13) {	// Gecko 13+ do not have favicon for livemark anymore
				// Livemark-item default icon is platform different, version different. Default is found from chrome://browser/skin/browser.css
				// Don't use function to get computed CSS because it may come from userChorme.css which may invalid. I need 100% valid default
				this.livemarkItemFaviconURI = this.defaultFaviconURI;
				this.livemarkItemFaviconURISpec = this.defaultFaviconURISpec;
				this.livemarkItemFaviconDataURISpec = this.defaultFaviconDataURISpec;
				try {
					var channel = this.ioService.newChannel("chrome://browser/skin/browser.css", 0, null);
					var stream = channel.open();
					var bstream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
					bstream.setInputStream(stream);
					var converterStream = Components.classes['@mozilla.org/intl/converter-input-stream;1'].createInstance(Components.interfaces.nsIConverterInputStream);
					converterStream.init(bstream, "UTF-8", bstream.available(),converterStream.DEFAULT_REPLACEMENT_CHARACTER);
					var output = {};
					converterStream.readString(bstream.available(), output);
					var browserCSS = output.value;
					converterStream.close();
					bstream.close();
					if (this.runtimeService.OS=="Darwin") {
						var selector = ".bookmark-item[livemark] .menuitem-iconic";
					} else {	// Linux and WINNT
						var selector = ".bookmark-item[container][livemark] .bookmark-item";
					}
					var index = browserCSS.indexOf(selector);
					if (index != -1) {
						browserCSS = browserCSS.substr(index);
						var index = browserCSS.indexOf("list-style-image:");
						if (index != -1) {
							browserCSS = browserCSS.substr(index+17);
							for (var i = 0; i < browserCSS.length; i++) {
								var quotation = browserCSS.charAt(i);
								if ((quotation == "'") || (quotation == '"')) {break;}
							}
							if (i < browserCSS.length) {
								browserCSS = browserCSS.substr(i+1);
								var index = browserCSS.indexOf(quotation);
								if (index != -1) {
									this.livemarkItemFaviconURISpec = browserCSS.split(quotation,1).toString();
									this.livemarkItemFaviconURI = this.ioService.newURI(this.livemarkItemFaviconURISpec, null, null);
									// cannot create livemarkItemDataURISpec by getFaviconDataAsDataURL because this function fail at this time
									// cannot create livemarkItemDataURISpec by canvas because new Image() is not work in module environment here
									var channel = this.ioService.newChannel(this.livemarkItemFaviconURISpec, 0, null);
									var stream = channel.open();
									var bstream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
									bstream.setInputStream(stream);
									this.livemarkItemFaviconDataURISpec = "data:image/png;base64," + btoa(bstream.readBytes(bstream.available()));
									bstream.close();
								}
							}
						}
					}
				} catch(e) {
					this.livemarkItemFaviconURI = this.defaultFaviconURI;
					this.livemarkItemFaviconURISpec = this.defaultFaviconURISpec;
					this.livemarkItemFaviconDataURISpec = this.defaultFaviconDataURISpec;
				}
			}
			this.checkUpdateAndFirstRun();
			this.crashRecover();
			Components.utils.import("resource://gre/modules/PlacesUtils.jsm");	// Not only use in saveBookmarkToJSONFile, this also use in observe bookmark onItemChanged and in placesContext
			// Hook function saveBookmarksToJSONFile in PlacesUtils.jsm or PlacesBackups.jsm for embeding favicon data into JSON file
			if (this.geckoBefore23) {
				this.saveBookmarksToJSONFile = PlacesUtils.backups.saveBookmarksToJSONFile;
				PlacesUtils.backups.saveBookmarksToJSONFile = function()
				{
					if (bookmarkfaviconchangerModule.saveBookmarksToJSONFileBusy) {
						throw "Bookmark Favicon Changer cannot backup bookmark if previous backup does not finish";
					} else {
						bookmarkfaviconchangerModule.saveBookmarksToJSONFileBusy = true;
						bookmarkfaviconchangerModule.lockCSS = true;
						bookmarkfaviconchangerModule.saveBookmarksToJSONFileThis = this;
						bookmarkfaviconchangerModule.saveBookmarksToJSONFileArguments = arguments;
						if (bookmarkfaviconchangerModule.branch.getBoolPref("embedFaviconInJSON")) {
							bookmarkfaviconchangerModule.embedJsonAnnotation(true);
						} else {
							bookmarkfaviconchangerModule.backupWithoutJsonAnnotation();
						}
						if (!bookmarkfaviconchangerModule.quitApplicationGranted) {
							bookmarkfaviconchangerModule.lockCSS = false;
							bookmarkfaviconchangerModule.changeCSS();
						}
						bookmarkfaviconchangerModule.saveBookmarksToJSONFileBusy = false;
						if (bookmarkfaviconchangerModule.errorCatch != null) {
							throw bookmarkfaviconchangerModule.errorCatch;
						}
					}
				};
			} else {
				// Gecko23 PlacesUtils.backups.saveBookmarksToJSONFile call PlacesBackups.saveBookmarksToJSONFile in
				//		resource://gre/modules/PlacesBackups.jsm then PlacesUtils.backups call
				//		BookmarkJSONUtils.exportToFile in "resource://gre/modules/BookmarkJSONUtils.jsm"
				// Backup bookmark while shutting down call PlacesBackups.saveBookmarksToJSONFile
				// Gecko23-24 backup in bookmark manager use PlacesOrganizer.backupBookmarks to call BookmarkJSONUtils.exportToFile
				// Gecko25 backup in bookmark manager use PlacesOrganizer.backupBookmarks to call PlacesBackups.saveBookmarksToJSONFile
				// BookmarkJSONUtils.exportToFile is freeze object and asynchronous.
				// 		Even I use clone method and replace it. It work a while but it return to original.
				//		Hook in XUL level work but not 100% sure.
				//		The best solution is to upgrade function PlacesOrganizer.backupBookmarks only in Gecko 23-34 to be like Gecko 25
				//		This will be done in xul level places.js
				//			The problem is it will make conflict with add-on that also change this function
				Components.utils.import("resource://gre/modules/PlacesBackups.jsm");
				this.saveBookmarksToJSONFile = PlacesBackups.saveBookmarksToJSONFile;
				PlacesBackups.saveBookmarksToJSONFile = function()
				{
					if (bookmarkfaviconchangerModule.saveBookmarksToJSONFileBusy) {
						throw "Bookmark Favicon Changer cannot backup bookmark if previous backup does not finish";
					} else {
						bookmarkfaviconchangerModule.saveBookmarksToJSONFileBusy = true;
						bookmarkfaviconchangerModule.lockCSS = true;
						bookmarkfaviconchangerModule.saveBookmarksToJSONFileThis = this;
						bookmarkfaviconchangerModule.saveBookmarksToJSONFileArguments = arguments;
						bookmarkfaviconchangerModule.saveBookmarksToJSONFileReturnValue = null;
						if (bookmarkfaviconchangerModule.branch.getBoolPref("embedFaviconInJSON")) {
							if (arguments.callee.caller.name === "fpCallback_done") {		// for callback file picker in firefox
								bookmarkfaviconchangerModule.embedJsonAnnotation(true);
							} else if (arguments.callee.caller.name === "PO_backupBookmarks") {	// for synchronous file picker in seamonkey
								bookmarkfaviconchangerModule.embedJsonAnnotation(true);
							} else {
								bookmarkfaviconchangerModule.embedJsonAnnotation(false);
							}
						} else {
							bookmarkfaviconchangerModule.backupWithoutJsonAnnotation();
						}
						if (!bookmarkfaviconchangerModule.quitApplicationGranted) {
							bookmarkfaviconchangerModule.lockCSS = false;
							bookmarkfaviconchangerModule.changeCSS();
						}
						bookmarkfaviconchangerModule.saveBookmarksToJSONFileBusy = false;
						if (bookmarkfaviconchangerModule.errorCatch != null) {
							throw bookmarkfaviconchangerModule.errorCatch;
						}
						return bookmarkfaviconchangerModule.saveBookmarksToJSONFileReturnValue;
					}
				};
			}
			Components.utils.import("resource://gre/modules/AddonManager.jsm");
			AddonManager.addAddonListener(this.addonListener);
			this.annotationService.addObserver(this.annotationListener);
			this.bookmarksService.addObserver(this.bookmarkListener, false);
			this.observerService.addObserver(this, "bookmarks-restore-success", false);
			this.observerService.addObserver(this, "quit-application-granted", false);
			this.changeCSS();
		}
	},
	checkUpdateAndFirstRun: function() {
		// Preference adjust by version change
		var thisVersion = 229;
		var prefVersion = this.branch.getIntPref("version");
		if (prefVersion != thisVersion) {
			// version before 140 is unstable and cannot upgrading
			// version before 150 has no pref version
			if (prefVersion < 160) {		// upgrading to version 1.60 use new namespace pageFaviconDataURISpecNS to store custom favicon for last line defense
				var uris = this.annotationService.getPagesWithAnnotation(this.pageOriginalFaviconURISpecNS);
				for (var i = 0; i < uris.length; i++) {
					try {
						try {
							var faviconURI = this.getFaviconForPage(uris[i]);
						} catch(e) {
							var faviconURI = this.getFaviconImageForPage(uris[i]);
						}
						// for safety, don't expect faviconURI as data : png because other addon may destroy it
						var faviconDataURISpec = this.getFaviconDataAsDataURL(uris[i], faviconURI);
						if (faviconDataURISpec != null) {
							this.annotationService.setPageAnnotation(uris[i],this.pageFaviconDataURISpecNS,faviconDataURISpec,0,4);
						}
					} catch(e) {
					}
				}
			}
			// if (prefVersion==0) {}		// First run checking, now there is no action for first run
			// Clean up for fresh new version
			this.purgeAnnotation();
			this.destroyOrphanAnnotation();
			this.destroyJsonAnnotation();
			// Setting pref to this version
			this.branch.setIntPref("version", thisVersion);
		}
	},
	crashRecover: function() {
		// Recover if there is a crash during bookmark backup process or annotation table destroy due to improper browser shutdown
		// For quicker process, recovery process done only when backup data > current annotation
		// Do not use progressmeter because thread.processNextEvent() may cause toolbar button appear too early before function hooking
		var backupFolderFaviconDataURISpec = this.branch.getCharPref("backupFolderFaviconDataURISpec");
		if (backupFolderFaviconDataURISpec!="") {
			if (backupFolderFaviconDataURISpec=="none") {
				// backupFolderFaviconDataURISpec = "none" is set by Json Backup (version before 1.60) mean no folder data but may be Json temporally data
				// Including in here for backward compatiblity (it should not happen)
				this.destroyJsonAnnotation();
			} else {
				var folderItemData = backupFolderFaviconDataURISpec.split(" ");
				var items = this.annotationService.getItemsWithAnnotation(this.itemFolderFaviconDataURISpecNS);
				if (folderItemData.length > items.length) {
					for (var i = 0; i < folderItemData.length; i++) {
						var eachItem = folderItemData[i].split("_");
						if (this.isUsableItemId(eachItem[0])) {
							try {
								this.annotationService.setItemAnnotation(Number(eachItem[0]),this.itemFolderFaviconDataURISpecNS,eachItem[1],0,4);
							} catch(e) {
							}
						}
					}
					// clean up
					this.purgeAnnotation();
					this.destroyOrphanAnnotation();
					this.destroyJsonAnnotation();
				}
			}
			this.branch.setCharPref("backupFolderFaviconDataURISpec","");	// clean out to prevent repeat crash recovery
		}
	},
	observe : function(subject, topic, data) {
		if (topic == "quit-application-granted") {
			this.quitApplicationGranted = true;
			Components.utils.import("resource://gre/modules/AddonManager.jsm");
			AddonManager.removeAddonListener(this.addonListener);
			this.annotationService.removeObserver(this.annotationListener);
			this.bookmarksService.removeObserver(this.bookmarkListener);
			this.observerService.removeObserver(this, "bookmarks-restore-success");
			this.observerService.removeObserver(this, "quit-application-granted");
			if (this.beingUninstalled) {
				this.lockCSS = true;
				this.destroyJsonAnnotation();
				this.destroyAnnotation(true);
				//this.branch.deleteBranch("");		//I think not delete preference is more standard . Version pref has effect on first run checking
			} else {
				this.purgeAnnotation();
				this.destroyOrphanAnnotation();
				this.destroyJsonAnnotation();
				if (this.beingDisabled) {
					this.lockCSS = true;
					this.branch.setCharPref("backupFolderFaviconDataURISpec","");		// disable backup so the crash recovery will not run when enable again
				}
			}
		} else if (topic == "bookmarks-restore-success") {
			if (data == "json") {
				// This event fire after onEndUpdateBatch - so the changeCSS() had call already once = folder icon had updated
				this.lockCSS = true;
				this.destroyAnnotation(false);		// clear existing annotation especially page annotation that may be left due to history did not be clear
				var folderJob = this.annotationService.getItemsWithAnnotation(this.itemJsonFolderFaviconDataURISpecNS);
				var bookmarkJob = this.annotationService.getItemsWithAnnotation(this.itemJsonFaviconDataURISpecNS);
				// check only itemJsonFaviconDataURISpecNS because itemJsonOriginalFaviconURISpecNS is present only if there is itemJsonFaviconDataURISpecNS
				if ((folderJob.length != 0) || (bookmarkJob.length != 0)) {
					// using modal type so it will not return until dialog close
					// Note -	Behavior of minimize button is different on platform for this setting (chrome,modal,titlebar,minimizable=yes,dialog=yes,centerscreen).
					//							|	Minimized button on titlebar	|	Minimized command in title menu
					//				Window		|				show				|					show
					//				MacOSx		|				show				|				no title menu
					//				Linux		|			  not show				|				  not show
					this.watcherService.openWindow(null,"chrome://bookmarkfaviconchanger/content/restore.xul",""
						,"chrome,modal,titlebar,minimizable=yes,dialog=yes,centerscreen",null);
				}
				this.purgeAnnotation();
				// this.destroyOrphanAnnotation();		// No need to do this at this time, let's do it at browser quit
				this.lockCSS = false;
				this.changeCSS();
			}
		}
	},
	bookmarkListener: {
		onBeforeItemRemoved: function() {},
		onBeginUpdateBatch: function() {
			bookmarkfaviconchangerModule.lockCSS = true;
		},
		onEndUpdateBatch: function() {
			bookmarkfaviconchangerModule.purgeAnnotation();
			// bookmarkfaviconchangerModule.destroyOrphanAnnotation();		// No need to do this at this time, let's do it at browser quit
			bookmarkfaviconchangerModule.lockCSS = false;
			bookmarkfaviconchangerModule.changeCSS();
		},
		onItemAdded: function() {},
		onItemChanged: function(aItemId, aProperty, aIsAnnotationProperty, aValue) {
			if (aProperty=="favicon") {
				// This is the last line of favicon protection
				try {
					var bookmarkURI = PlacesUtils.bookmarks.getBookmarkURI(aItemId);
					// For backward compatibility, I determine that pageFaviconDataURISpecNS is valid only if pageOriginalFaviconURISpecNS valid
					var originalFaviconURISpec = bookmarkfaviconchangerModule.annotationService.getPageAnnotation(bookmarkURI
						,bookmarkfaviconchangerModule.pageOriginalFaviconURISpecNS);
					var faviconDataURISpec = bookmarkfaviconchangerModule.annotationService.getPageAnnotation(bookmarkURI
						,bookmarkfaviconchangerModule.pageFaviconDataURISpecNS);
					if (faviconDataURISpec != aValue) {
						try {
							var faviconURI = bookmarkfaviconchangerModule.ioService.newURI(faviconDataURISpec, null, null);
							// Recursive marker is not work due to setAndLoadFaviconForPage is run asynchronous later, this function is exit first.
							bookmarkfaviconchangerModule.setAndLoadFaviconForPage(bookmarkURI,faviconURI,false,null);
						} catch(e) {
						}
					}
				} catch(e) {
				}
			}
		},
		onItemMoved: function() {},
		onItemRemoved: function() {
			// cannot use aItemID to get bookmark URI and to get annotation because it had removed.
			bookmarkfaviconchangerModule.purgeAnnotation();
			// bookmarkfaviconchangerModule.destroyOrphanAnnotation();		// No need to do this at this time, let's do it at browser quit
		},
		onItemVisited: function() {},
		QueryInterface: function(iid) {
			if (iid.equals(Components.interfaces.nsINavBookmarkObserver) || iid.equals(Components.interfaces.nsISupports)) { return this; }
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}
	},
	addonListener: {
		onDisabling: function(addon) {
			if (addon.id == "bookmarkfaviconchanger@sonthakit") {
				bookmarkfaviconchangerModule.beingDisabled = true;
			}
		},
		onUninstalling: function(addon) {
			if (addon.id == "bookmarkfaviconchanger@sonthakit") {
				bookmarkfaviconchangerModule.beingUninstalled = true;
			}
		},
		onOperationCancelled: function(addon) {
			if (addon.id == "bookmarkfaviconchanger@sonthakit") {
				Components.utils.import("resource://gre/modules/AddonManager.jsm");
				bookmarkfaviconchangerModule.beingUninstalled = ((addon.pendingOperations & AddonManager.PENDING_UNINSTALL) != 0);
				bookmarkfaviconchangerModule.beingDisabled = ((addon.pendingOperations & AddonManager.PENDING_DISABLE) != 0);
			}
		}
	},
	annotationListener: {
		onPageAnnotationSet: function(aURI, aName) {},
		onItemAnnotationSet: function(aItemId, aName) {
			if (aName==bookmarkfaviconchangerModule.itemFolderFaviconDataURISpecNS) {
				bookmarkfaviconchangerModule.changeCSS();
			}
		},
		onPageAnnotationRemoved : function(aURI, aName) {},
		onItemAnnotationRemoved: function(aItemId, aName) {
			if ((aName=="") || (aName==bookmarkfaviconchangerModule.itemFolderFaviconDataURISpecNS)) {
				bookmarkfaviconchangerModule.changeCSS();
			}
		}
	},
	embedJsonAnnotation: function(manualBookmarkBackup) {
		this.embedJsonAnnotationSliceStage = 0;
		this.embedJsonAnnotationSlice();			// this also lock CSS
		if ((this.totalJob > 1) && (!this.quitApplicationGranted)) {
			// Background task
			// Aim - I need to run background task and user interface enable. But this function must not return until embed finish.
			// Previously (version before 1.61) I use processNextEvent to solve this problem. But this command is not a safe one.
			// New method is to open modal window. Use modal to do background task. Return when finish.
			// 		Pro - don't use processNextEvent. Con - User cannot closed the modal window (but can minimize or change focus).
			// Note -	dialog=yes must include. So I can use ondialogcancel to manipulate user close the dialog. dialog=no is not work
			//			Behavior of minimize button is different on platform for this setting (chrome,modal,titlebar,minimizable=yes,dialog=yes,centerscreen).
			//							|	Minimized button on titlebar	|	Minimized command in title menu
			//				Window		|				show				|					show
			//				MacOSx		|				show				|				no title menu
			//				Linux		|			  not show				|				  not show
			// Gecko 23+ function saveBookmarkToJSONFile is asynchronous. I don't need to show dialog when auto bookmark backup
			if ((!bookmarkfaviconchangerModule.geckoBefore23) && (!manualBookmarkBackup)) {
				var currentThread = this.threadService.currentThread;
				while (this.embedJsonAnnotationSlice() != -1) {
					currentThread.processNextEvent(false);
				}
			} else {
				this.watcherService.openWindow(null,"chrome://bookmarkfaviconchanger/content/embed.xul",""
					,"chrome,modal,titlebar,minimizable=yes,dialog=yes,centerscreen",null);
			}
		} else {
			// Silent foreground task - no user interface allow
			while (this.embedJsonAnnotationSlice() != -1) {
			}
		}
	},
	totalJob: null,
	currentJob: null,
	saveAnnotationItem: null,
	saveAnnotationItemData: null,
	saveNodeItemId: null,
	saveNodeURI: null,
	embedJsonAnnotationSliceStage: 0,
	embedJsonAnnotationSliceStagePart: 0,
	errorCatch: null,
	embedJsonAnnotationSlice: function() {
		// Aim to have backward and forward compatibility, extensibility as much as possible for future use
		//
		// Annotation for folder
		//		I need to temporally change annotation to session expire so they will not sustain when import by browser that do not have this extension
		//			Session expire namespace = "itemJsonFolderFaviconDataURISpecNS"
		//		I also use this variable to increase speed and more accuracy due to user freely to manipulate bookmark
		//			saveAnnotationItem 			= array of itemID
		//			saveAnnotationItemData		= array of annotation data
		//
		// Annotation for bookmark
		// 		Namespace "itemJsonFaviconDataURISpecNS" - for storage favicon data URI Spec - session expire
		//			note that this favicon is a current showing favicon, not favicon data save in pageFaviconDataURISpecNS (what you see is what you get policy)
		//		Namespace "itemJsonOriginalFaviconURISpecNS" - for storage original favicon URI spec - session expire
		//			itemJsonOriginalFaviconURISpecNS can present only if itemJsonFaviconDataURISpecNS is present
		//		I also use this variable to increase speed and more accuracy due to user freely to manipulate bookmark
		// 			saveNodeItemId 		= array of itemID of all bookmarks
		//			saveNodeURI			= array of URI of all bookmarks
		//
		// Let's browser decided what should backup, eg. Livemark item usually not backup (it's annotation too)
		//		This will make JSON file size as small as possible
		//
		// Job progress 0-100%, each individual job weight equally.
		//
		// This function do the embed job in piece.
		//		First call should set variable embedJsonAnnotationSliceStage to 0 before call.
		//		Return the currentJob (Range from 0 to totalJob)
		//		Return -1 if finish
		this.lockCSS = true;		// for safety unexpected recursive
		switch (this.embedJsonAnnotationSliceStage) {
			case 0:					// prepare all variable
				this.destroyJsonAnnotation();
				this.saveAnnotationItem = this.annotationService.getItemsWithAnnotation(this.itemFolderFaviconDataURISpecNS);
				this.saveAnnotationItemData = new Array(this.saveAnnotationItem.length);
				var query = this.historyService.getNewQuery();
				query.setFolders([this.bookmarksService.toolbarFolder, this.bookmarksService.bookmarksMenuFolder, this.bookmarksService.unfiledBookmarksFolder],3);
				var options = this.historyService.getNewQueryOptions();
				options.queryType = options.QUERY_TYPE_BOOKMARKS;
				var resultContainerNode = this.historyService.executeQuery(query, options).root;
				resultContainerNode.containerOpen = true;
				this.saveNodeURI = new Array(resultContainerNode.childCount);
				this.saveNodeItemId = new Array(resultContainerNode.childCount);
				for (var i=0; i < resultContainerNode.childCount; i++) {
					this.saveNodeItemId[i] = resultContainerNode.getChild(i).itemId;
					this.saveNodeURI[i] = resultContainerNode.getChild(i).uri;
				}
				resultContainerNode.containerOpen = false;
				this.totalJob = ((this.saveNodeItemId.length + this.saveAnnotationItem.length)*2)+1;
				this.currentJob = 0;
				this.embedJsonAnnotationSliceStage++;
				this.embedJsonAnnotationSliceStagePart = 0;
				return 0;			// = return this.currentJob;
				break;
			case 1:					// embed favicon of bookmark uri
				if (this.saveNodeItemId.length != 0) {
					var i = this.embedJsonAnnotationSliceStagePart;
					try {
						var bookmarkURISpec = this.saveNodeURI[i];
						var bookmarkURI = this.ioService.newURI(bookmarkURISpec, null, null);
						try {
							var originalFaviconURISpec = this.annotationService.getPageAnnotation(bookmarkURI,this.pageOriginalFaviconURISpecNS);
						} catch(e) {
							var originalFaviconURISpec = "";
						}
						var faviconURI = this.getFaviconForPage(bookmarkURI);
						//	Throw error if no favicon, I will not use getFaviconImageForPage to rescue. If it has no favicon, just drop it
						var faviconURISpec = faviconURI.spec;
						if ((originalFaviconURISpec !="") || (!this.isDefaultFavicon(faviconURISpec))) {
							var faviconDataURISpec = this.getFaviconDataAsDataURL(bookmarkURI, faviconURI);
							if (faviconDataURISpec != null) {
								this.annotationService.setItemAnnotation(this.saveNodeItemId[i],this.itemJsonFaviconDataURISpecNS
									,faviconDataURISpec,0,0);					// use expire session
								if (originalFaviconURISpec != "") {
									this.annotationService.setItemAnnotation(this.saveNodeItemId[i],this.itemJsonOriginalFaviconURISpecNS
										,originalFaviconURISpec,0,0);			// use expire session
								}
							}
						}
					} catch(e) {
					}
					this.embedJsonAnnotationSliceStagePart++;
					this.currentJob ++;
				}
				if (this.embedJsonAnnotationSliceStagePart == this.saveNodeItemId.length) {
					this.embedJsonAnnotationSliceStage++;
					this.embedJsonAnnotationSliceStagePart = 0;
				}
				return this.currentJob;
				break;
			case 2:					// embed favicon of folder
				if (this.saveAnnotationItem.length != 0) {
					var i = this.embedJsonAnnotationSliceStagePart;
					try {
						this.saveAnnotationItemData[i] = this.annotationService.getItemAnnotation(this.saveAnnotationItem[i],this.itemFolderFaviconDataURISpecNS);
						this.annotationService.removeItemAnnotation(this.saveAnnotationItem[i],this.itemFolderFaviconDataURISpecNS);
						this.annotationService.setItemAnnotation(this.saveAnnotationItem[i],this.itemJsonFolderFaviconDataURISpecNS,this.saveAnnotationItemData[i],0,0);
					} catch(e) {
					}
					this.embedJsonAnnotationSliceStagePart++;
					this.currentJob ++;
				}
				if (this.embedJsonAnnotationSliceStagePart == this.saveAnnotationItem.length) {
					this.embedJsonAnnotationSliceStage++;
					this.embedJsonAnnotationSliceStagePart = 0;
				}
				return this.currentJob;
				break;
			case 3:					// apply
				this.errorCatch = null;
				try {
					if (this.geckoBefore24) {
						this.saveBookmarksToJSONFile.apply(this.saveBookmarksToJSONFileThis, this.saveBookmarksToJSONFileArguments);
					} else if (this.geckoBefore25) {
						// Gecko24 use asynchronous serializeNodeAsJSONToOutputStream
						//		So processing to create JSON is still not finish when function return
						//		This make immediately remove annotation after call saveBookmarkToJSONFile effect the bookmark backup file.
						//		I should wait for backup file until saving finished but there is no way good to do it.
						//		So I replace all of the function to synchronous
						this.saveBookmarksToJSONFileReturnValue = this.saveBookmarksToJSONFileForGecko24.apply(this.saveBookmarksToJSONFileThis, this.saveBookmarksToJSONFileArguments);
					} else {
						// Gecko25 like Gecko24 but has return value = nodeCount
						this.saveBookmarksToJSONFileReturnValue = this.saveBookmarksToJSONFileForGecko25.apply(this.saveBookmarksToJSONFileThis, this.saveBookmarksToJSONFileArguments);
					}
				} catch(e) {
					this.errorCatch = e;
				}
				this.lockCSS = true;		// for safety unexpected recursive
				this.currentJob ++;
				this.embedJsonAnnotationSliceStage++;
				this.embedJsonAnnotationSliceStagePart = 0;
				return this.currentJob;
				break;
			case 4:					// remove embed favicon of bookmark uri (reverse case 1)
				if (this.saveNodeItemId.length != 0) {
					var i = this.embedJsonAnnotationSliceStagePart;
					try {
						this.annotationService.removeItemAnnotation(this.saveNodeItemId[i],this.itemJsonFaviconDataURISpecNS);
						try {
							this.annotationService.removeItemAnnotation(this.saveNodeItemId[i],this.itemJsonOriginalFaviconURISpecNS);
						} catch(e) {
						}
					} catch(e) {
					}
					this.embedJsonAnnotationSliceStagePart++;
					this.currentJob ++;
				}
				if (this.embedJsonAnnotationSliceStagePart == this.saveNodeItemId.length) {
					this.embedJsonAnnotationSliceStage++;
					this.embedJsonAnnotationSliceStagePart = 0;
				}
				return this.currentJob;
				break;
			case 5:					// remove embed favicon of folder (reverse case 2)
				if (this.saveAnnotationItem.length != 0) {
					var i = this.embedJsonAnnotationSliceStagePart;
					try {
						this.annotationService.setItemAnnotation(this.saveAnnotationItem[i],this.itemFolderFaviconDataURISpecNS,this.saveAnnotationItemData[i],0,4);
						this.annotationService.removeItemAnnotation(this.saveAnnotationItem[i],this.itemJsonFolderFaviconDataURISpecNS);
					} catch(e) {
					}
					this.embedJsonAnnotationSliceStagePart++;
					this.currentJob ++;
				}
				if (this.embedJsonAnnotationSliceStagePart == this.saveAnnotationItem.length) {
					this.embedJsonAnnotationSliceStage++;
					this.embedJsonAnnotationSliceStagePart = 0;
				}
				return this.currentJob;
				break;
			case 6:					// clean data for release memory
				this.totalJob = null;
				this.currentJob = null;
				this.saveAnnotationItem = null;
				this.saveAnnotationItemData = null;
				this.saveNodeItemId = null;
				this.saveNodeURI = null;
				this.embedJsonAnnotationSliceStage = 0;
				this.embedJsonAnnotationSliceStagePart = 0;
				return -1;
				break;
		}
	},
	backupWithoutJsonAnnotation: function() {
		// Aim to have backward and forward compatibility, extensibility as much as possible for future use
		//
		// Annotation for folder
		//		If user don't want to backup favicon - to decrease JSON size, temporally delete before backup, undelete when backup finish.
		//			I also use this variable to increase speed and more accuracy due to user freely to manipulate bookmark
		// 				saveAnnotationItem 			= array of itemID
		//				saveAnnotationItemData		= array of annotation data
		//
		// Annotation for bookmark
		//		No need to change, normally pageAnnotation cannot backup
		//
		// Usually doing this is short time because folder is not much - no need to do background task and show progress meter
		this.lockCSS = true;		// for safety unexpected recursive
		this.destroyJsonAnnotation();
		this.saveAnnotationItem = this.annotationService.getItemsWithAnnotation(this.itemFolderFaviconDataURISpecNS);
		this.saveAnnotationItemData = new Array(this.saveAnnotationItem.length);
		for (var i = 0; i < this.saveAnnotationItem.length; i++) {
			try {
				this.saveAnnotationItemData[i] = this.annotationService.getItemAnnotation(this.saveAnnotationItem[i],this.itemFolderFaviconDataURISpecNS);
				this.annotationService.removeItemAnnotation(this.saveAnnotationItem[i],this.itemFolderFaviconDataURISpecNS);
			} catch(e) {
			}
		}
		this.errorCatch = null;
		this.saveBookmarksToJSONFileReturnValue = null;
		try {
			if (this.geckoBefore24) {
				this.saveBookmarksToJSONFile.apply(this.saveBookmarksToJSONFileThis, this.saveBookmarksToJSONFileArguments);
			} else if (this.geckoBefore25) {
				// Gecko24 use asynchronous serializeNodeAsJSONToOutputStream
				//		So processing to create JSON is still not finish when function return
				//		This make immediately remove annotation after call saveBookmarkToJSONFile effect the bookmark backup file.
				//		I should wait for backup file until save finished but there is no way good to do it.
				//		So I replace all of the function to synchronous
				this.saveBookmarksToJSONFileReturnValue = this.saveBookmarksToJSONFileForGecko24.apply(this.saveBookmarksToJSONFileThis, this.saveBookmarksToJSONFileArguments);
			} else {
				// Gecko25 like Gecko24 but has return value = nodeCount
				this.saveBookmarksToJSONFileReturnValue = this.saveBookmarksToJSONFileForGecko25.apply(this.saveBookmarksToJSONFileThis, this.saveBookmarksToJSONFileArguments);
			}
		} catch(e) {
			this.errorCatch = e;
		}
		this.lockCSS = true;		// for safety unexpected recursive
		for (var i = 0; i < this.saveAnnotationItem.length; i++) {
			try {
				this.annotationService.setItemAnnotation(this.saveAnnotationItem[i],this.itemFolderFaviconDataURISpecNS,this.saveAnnotationItemData[i],0,4);
			} catch(e) {
			}
		}
		this.saveAnnotationItem = null;
		this.saveAnnotationItemData = null;
	},
	isUsableItemId: function(itemId) {
		// return true if itemId is folder and can be used
		try {
			if (itemId == null) {return false;}
			if (isNaN(Number(itemId))) {return false;}
			if (itemId < 0) {return false;}
			if (itemId == this.bookmarksService.toolbarFolder) {return false;}
			if (itemId == this.bookmarksService.bookmarksMenuFolder) {return false;}
			if (itemId == this.bookmarksService.unfiledBookmarksFolder) {return false;}
			if (itemId == this.bookmarksService.placesRoot) {return false;}
			if (itemId == this.bookmarksService.tagsFolder) {return false;}
			if (this.bookmarksService.getItemType(itemId)!=2) {return false;}		//not folder
			return true;
		} catch(e) {
			return false;
		}
	},
	isDefaultFavicon: function(aURISpec) {
		try {
			if (aURISpec == this.defaultFaviconURISpec) {return true;}
			if (aURISpec == this.defaultFaviconDataURISpec) {return true;}
			if (this.geckoBefore13) {
				if (aURISpec == this.livemarkItemFaviconURISpec) {return true;}
				if (aURISpec == this.livemarkItemFaviconDataURISpec) {return true;}
			}
			return false;
		} catch(e) {
			return false;
		}
	},
	changeCSS: function() {
		// This function also save backup of folder favicon data in pref so if browser crash or annotation table destroyed, it can recover when restart
		// Pref backupFolderFaviconDataURISpec = [id + "_" +folderFavicondataURIspec] + " " +...
		if (!this.lockCSS) {
			var CSSDataURISpec = "";
			var backupFolderFaviconDataURISpec = "";
			var items = this.annotationService.getItemsWithAnnotation(this.itemFolderFaviconDataURISpecNS);
			if (items.length != 0) {
				var sortItems = new Array(items.length);
				var sortItemsLength = 0;
				for (var i = 0; i < items.length; i++) {			// removue unusable item id
					if (this.isUsableItemId(items[i])) {
						sortItems[sortItemsLength] = items[i];
						sortItemsLength ++;
					}
				}
				if (sortItemsLength != 0) {
					if (sortItemsLength > 1) {				// sort the item by increasing number
						var sortFinish = false;
						while (!sortFinish) {
							sortFinish = true;
							for (var i = 0; i < (sortItemsLength-1); i++) {
								if (sortItems[i] > sortItems[i+1]) {
									var tempItem = sortItems[i+1];
									sortItems[i+1] = sortItems[i];
									sortItems[i] = tempItem;
									sortFinish = false;
								}
							}
						}
					}
					var cssContent = '@namespace url("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");'+"\n";
					for (var i = 0; i < sortItemsLength; i++) {
						var folderFaviconDataURISpec = this.annotationService.getItemAnnotation(sortItems[i],this.itemFolderFaviconDataURISpecNS);
						cssContent = cssContent
							+ '[bookmarkfaviconchanger="' + sortItems[i] + '"]'
							+ ',treechildren::-moz-tree-image(bookmarkfaviconchanger' + sortItems[i] + ')'
							+ '{list-style-image:url("'	+ folderFaviconDataURISpec + '") !important; -moz-image-region: auto !important;}'+"\n";
						backupFolderFaviconDataURISpec += " "+sortItems[i]+"_"+folderFaviconDataURISpec;
					}
					CSSDataURISpec = "data:text/css;base64," + btoa(cssContent);
					backupFolderFaviconDataURISpec = backupFolderFaviconDataURISpec.substr(1);
				}
			}
			if (this.myCSSDataURISpec != CSSDataURISpec) {
				if (this.myCSSDataURISpec != "") {
					this.styleSheetService.unregisterSheet(this.ioService.newURI(this.myCSSDataURISpec, null, null), 1);
				}
				this.myCSSDataURISpec = CSSDataURISpec;
				if (this.myCSSDataURISpec != "") {
					this.styleSheetService.loadAndRegisterSheet(this.ioService.newURI(this.myCSSDataURISpec, null, null), 1);
				}
				this.branch.setCharPref("backupFolderFaviconDataURISpec",backupFolderFaviconDataURISpec);
				this.observerService.notifyObservers(null, "bookmarkfaviconchangerBroadcast", "newCSS");
			}
		}
 	},
	purgeAnnotation: function() {
		var uris = this.annotationService.getPagesWithAnnotation(this.pageOriginalFaviconURISpecNS);
		for (var i = 0; i < uris.length; i++) {
			if (!this.bookmarksService.isBookmarked(uris[i])) {
				this.annotationService.removePageAnnotation(uris[i],this.pageOriginalFaviconURISpecNS);
				try {
					this.annotationService.removePageAnnotation(uris[i],this.pageFaviconDataURISpecNS);
				} catch(e) {
				}
			}
		}
	},
	destroyOrphanAnnotation: function() {
		// pageFaviconDataURISpecNS should present only if there is pageOriginalFaviconURISpecNS
		// 		Left this annotation do no effect, for quick browser speed, remove it only when browser quit, add-on version upgrade or crash recovery
		//		Please call this after purgeAnnotation, it will make this function don't need to call this.bookmarksService.isBookmarked(uris[i])
		var uris = this.annotationService.getPagesWithAnnotation(this.pageFaviconDataURISpecNS);
		for (var i = 0; i < uris.length; i++) {
			try {
				var originalFaviconURISpec = this.annotationService.getPageAnnotation(uris[i],this.pageOriginalFaviconURISpecNS);
			} catch(e) {
				this.annotationService.removePageAnnotation(uris[i],this.pageFaviconDataURISpecNS);
			}
		}
	},
	destroyJsonAnnotation: function() {
		// Usually Json Annotation is session expire, call this proc only if necessary or for safety
		// using try catch because this proc may call from function saveBookmarksToJSONFile which may be background, some annotation may be deleted at that time
		var items = this.annotationService.getItemsWithAnnotation(this.itemJsonFolderFaviconDataURISpecNS);
		for (var i = 0; i < items.length; i++) {
			try {
				this.annotationService.removeItemAnnotation(items[i],this.itemJsonFolderFaviconDataURISpecNS);
			} catch(e) {
			}
		}
		var items = this.annotationService.getItemsWithAnnotation(this.itemJsonFaviconDataURISpecNS);
		for (var i = 0; i < items.length; i++) {
			try {
				this.annotationService.removeItemAnnotation(items[i],this.itemJsonFaviconDataURISpecNS);
			} catch(e) {
			}
		}
		var items = this.annotationService.getItemsWithAnnotation(this.itemJsonOriginalFaviconURISpecNS);
		for (var i = 0; i < items.length; i++) {
			try {
				this.annotationService.removeItemAnnotation(items[i],this.itemJsonOriginalFaviconURISpecNS);
			} catch(e) {
			}
		}
	},
	destroyAnnotation: function(restoreFavicon) {
		// This must be run under lockCSS = true
		// I don't put code lockCSS=true then false in this proc because when quit application, it should not turn lockCSS back to false
		// This function do not destroy JSON annotation
		var uris = this.annotationService.getPagesWithAnnotation(this.pageOriginalFaviconURISpecNS);
		for (var i = 0; i < uris.length; i++) {
			if (restoreFavicon) {
				if (this.bookmarksService.isBookmarked(uris[i])) {
					var originalFaviconURISpec = this.annotationService.getPageAnnotation(uris[i],this.pageOriginalFaviconURISpecNS);
					var originalFaviconURI = this.ioService.newURI(originalFaviconURISpec, null, null);
					this.annotationService.removePageAnnotation(uris[i],this.pageOriginalFaviconURISpecNS);
					if (this.quitApplicationGranted) {
						this.setFaviconUrlForPage(uris[i],originalFaviconURI);
					} else {
						this.setAndLoadFaviconForPage(uris[i],originalFaviconURI,true,null);	// asynchronous operation is not accept when quitting
					}
				}
			} else {
				this.annotationService.removePageAnnotation(uris[i],this.pageOriginalFaviconURISpecNS);
			}
		}
		var uris = this.annotationService.getPagesWithAnnotation(this.pageFaviconDataURISpecNS);
		for (var i = 0; i < uris.length; i++) {
			this.annotationService.removePageAnnotation(uris[i],this.pageFaviconDataURISpecNS);
		}
		var items = this.annotationService.getItemsWithAnnotation(this.itemFolderFaviconDataURISpecNS);
		for (var i = 0; i < items.length; i++) {
			this.annotationService.removeItemAnnotation(items[i],this.itemFolderFaviconDataURISpecNS);
		}
		this.branch.setCharPref("backupFolderFaviconDataURISpec","");
	},
	getImageTypeFromURI: function(inputURI,inputURISpec) {
		// if inputURISpec is dataURI, inputURI will ignore
		// return in array[0]=extension ("" if unknown), array[1]=Filter title, array[2]=filter
		var result = new Array(3);
		result[0] = "";
		result[1] = "";
		result[2] = "";
		if (inputURISpec.substr(0,5) == ("data:")) {
			var contentType = inputURISpec.split(",",1).toString().substr(5);
			if (contentType.length > 7) {
				if (contentType.substr(contentType.length-7,7) == ";base64") {
					contentType = contentType.substr(0,contentType.length-7);
				}
			}
		} else {
			try {
				// don't use nsiMIMEService at first because it is not well establish in Mozilla reference
				var contentType = Components.classes["@mozilla.org/mime;1"].getService(Components.interfaces.nsIMIMEService).getTypeFromURI(inputURI);
			} catch(e) {
				return result;
			}
		}
		if (contentType.substr(0,6) == "image/") {
			contentType = contentType.substr(6);
			switch (contentType) {
				case "vnd.microsoft.icon":
				case "ico":
				case "x-icon":
					result[0] = "ico";
					result[1] = "Icon File";
					result[2] = "*.ico";
					break;
				case "x-ms-bmp":
				case "x-bmp":
				case "dib":		// usually no such MIME type
				case "bmp":
					result[0] = "bmp";
					result[1] = "Bitmap Image File";
					result[2] = "*.bmp; *.dib";
					break;
				case "gif":
					result[0] = "gif";
					result[1] = "Graphics Interchange Format File";
					result[2] = "*.gif";
					break;
				case "jpe":		// usually no such MIME type
				case "jpg":		// usually no such MIME type
				case "jif":		// usually no such MIME type
				case "jfi":		// usually no such MIME type
				case "jfif":	// usually no such MIME type
				case "jpeg":
					result[0] = "jpg";
					result[1] = "Joint Photographic Experts Group File";
					result[2] = "*.jpg; *.jpe; *.jpeg; *.jif; *.jfi; *.jfif";
					break;
				case "apng":	// usually no such MIME type
				case "png":
					result[0] = "png";
					result[1] = "Portable Network Graphics File";
					result[2] = "*.png; *.apng";
					break;
				case "svg":		// usually no such MIME type
				case "svg+xml":
					result[0] = "svg";
					result[1] = "Scalable Vector Graphics File";
					result[2] = "*.svg";
					break;
			}
			if (result[2]!="") {
				result[1] += " (" + result[2] + ")";
			}
		}
		return result;
	},
	getDefaultDirectory: function() {
		// return default directory as nsiLocalFile
		var result = null;
		try {
			result = this.branch.getComplexValue("defaultFolder", Components.interfaces.nsILocalFile);
		} catch(e) {
			try {
				var newDisplayDirectory = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				var textDisplayDirectory = this.branch.getCharPref("defaultFolder");
				textDisplayDirectory = textDisplayDirectory.replace(/^\s+|\s+$/g, "");
				newDisplayDirectory.initWithPath(textDisplayDirectory);
				result = newDisplayDirectory;
			} catch(e) {
			}
		}
		return result;
	},
	//=========================================================
	//  Gecko 22 Patch function - Synchronous Favicon Service
	//=========================================================
	mozIAsyncFavicons: Components.classes["@mozilla.org/browser/favicon-service;1"].getService(Components.interfaces.mozIAsyncFavicons),
	nextId: 1,
	queue: [],
	setData: function(id, data) {
		var i = 0;
		while (this.queue[i].id !== -id) { i++; }
		this.queue[i].id = id;
		this.queue[i].data = data;
	},
	getFaviconDataAsDataURL: function(aPageURI, aFaviconURI) {
		if (this.geckoBefore22) {
			return this.faviconService.getFaviconDataAsDataURL(aFaviconURI);
		} else {
			var id = this.nextId;
			this.nextId ++;
			this.queue.push({id:-id, data:null});
			if (aFaviconURI == this.defaultFaviconURI) {
				this.setData(id, this.defaultFaviconDataURISpec);	//defaultFavionDataURISpec is null in the initial, result is throw exception
			} else {
				this.mozIAsyncFavicons.getFaviconDataForPage(aPageURI,
					{
						onComplete: function(aURI, aDataLen, aData, aMimeType) {
							if (aURI === null) {
								bookmarkfaviconchangerModule.setData(id, null);
							} else if (aDataLen === 0) {
								bookmarkfaviconchangerModule.setData(id, "");
							} else {
								var faviconDataURI = "";
								for (var i = 0; i < aDataLen; i++) { faviconDataURI += String.fromCharCode(aData[i]); }
								faviconDataURI = "data:" + aMimeType + ";base64," + btoa(faviconDataURI);
								bookmarkfaviconchangerModule.setData(id, faviconDataURI);
							}
						}
					}
				);
			}
			var currentThread = this.threadService.currentThread;
			while (this.queue[0].id !== id) { currentThread.processNextEvent(true); }
			var data = this.queue.shift().data;
			if (data === null) {
				throw "NS_ERROR_NOT_AVAILABLE";
			} else if (data === "") {
				return null;
			} else {
				return data;
			}
		}
	},
	getFaviconForPage: function(aPageURI) {
		if (this.geckoBefore22) {
			return this.faviconService.getFaviconForPage(aPageURI);
		} else {
			var id = this.nextId;
			this.nextId ++;
			this.queue.push({id:-id, data:null});
			this.mozIAsyncFavicons.getFaviconURLForPage(aPageURI,
				{
					onComplete: function(aURI, aDataLen, aData, aMimeType) {
						bookmarkfaviconchangerModule.setData(id, aURI);
					}
				}
			);
			var currentThread = this.threadService.currentThread;
			while (this.queue[0].id !== id) { currentThread.processNextEvent(true); }
			var data = this.queue.shift().data;
			if (data === null) {
				throw "NS_ERROR_NOT_AVAILABLE";
			} else if (data === "") {
				throw "NS_ERROR_NOT_AVAILABLE";
			} else {
				return data;
			}
		}
	},
	getFaviconImageForPage: function(aPageURI) {
		if (this.geckoBefore22) {
			return this.faviconService.getFaviconImageForPage(aPageURI);
		} else {
			var id = this.nextId;
			this.nextId ++;
			this.queue.push({id:-id, data:null});
			this.mozIAsyncFavicons.getFaviconURLForPage(aPageURI,
				{
					onComplete: function(aURI, aDataLen, aData, aMimeType) {
						bookmarkfaviconchangerModule.setData(id, aURI);
					}
				}
			);
			var currentThread = this.threadService.currentThread;
			while (this.queue[0].id !== id) { currentThread.processNextEvent(true); }
			var data = this.queue.shift().data;
			if (data === null) {
				return this.defaultFaviconURI;
			} else if (data === "") {
				throw "NS_ERROR_NOT_AVAILABLE";
			} else {
				return data;
			}
		}
	},
	setAndLoadFaviconForPage: function(aPageURI, aFaviconURI, aForceReload, aCallback) {
		if (this.geckoBefore18) {
			//setAndLoadFaviconForPage is mess in Gecko 18. It shift 4th parameter to the 5th and add non-optional 4th argument for private browsing
			if (aCallback) {
				this.faviconService.setAndLoadFaviconForPage(aPageURI, aFaviconURI, aForceReload, aCallback);
			} else {
				this.faviconService.setAndLoadFaviconForPage(aPageURI, aFaviconURI, aForceReload);
			}
		} else if (this.geckoBefore22) {
			// Absolutely need to save favicon even in private-browsing due to bookmark favicon is application level, not per-window level.
			// If it is not save, new custom favicon will lost when quit application.
			if (aCallback) {
				this.faviconService.setAndLoadFaviconForPage(aPageURI, aFaviconURI, aForceReload, this.faviconService.FAVICON_LOAD_NON_PRIVATE, aCallback);
			} else {
				this.faviconService.setAndLoadFaviconForPage(aPageURI, aFaviconURI, aForceReload, this.faviconService.FAVICON_LOAD_NON_PRIVATE);
			}
		} else {
			// Gecko 22 use mozIAsyncFavicons
			if (aCallback) {
				this.mozIAsyncFavicons.setAndFetchFaviconForPage(aPageURI, aFaviconURI, aForceReload, this.faviconService.FAVICON_LOAD_NON_PRIVATE, aCallback);
			} else {
				this.mozIAsyncFavicons.setAndFetchFaviconForPage(aPageURI, aFaviconURI, aForceReload, this.faviconService.FAVICON_LOAD_NON_PRIVATE);
			}
		}
	},
	setFaviconUrlForPage: function (aPageURI, aFaviconURI) {
		if (this.geckoBefore22) {
			this.faviconService.setFaviconUrlForPage(aPageURI, aFaviconURI);
		} else {
			this.mozIAsyncFavicons.setAndFetchFaviconForPage(aPageURI, aFaviconURI, true, this.faviconService.FAVICON_LOAD_NON_PRIVATE);
		}
	},
	//==================================================================
	//  Gecko 24 Patch function - PlacesBackups.saveBookmarksToJSONFile
	//==================================================================
	saveBookmarksToJSONFileForGecko24: function(aFile) {
		// This is my synchronous function modified from Gecko 21, Begin use in Gecko 24+ to replace asyn PlacesBackup.saveBookmarksToJSONFile
		Components.utils.import("resource://gre/modules/PlacesUtils.jsm");
		if (!aFile.exists()) {
			aFile.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, parseInt("0600", 8));
		}
		if (!aFile.exists() || !aFile.isWritable()) {
			Components.utils.reportError("Unable to create bookmarks backup file: " + aFile.leafName);
			return;
		}
		// --------------------------------------------------
		// Replace this._writeBackupFile(aFile);
		// --------------------------------------------------
			let stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
			stream.init(aFile, 0x02 | 0x08 | 0x20, 0600, 0);
			let converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
			converter.init(stream, "UTF-8", 0, 0x0000);
			let streamProxy = {
				converter: converter,
				write: function(aData, aLen) {
					this.converter.writeString(aData);
				}
			};
			let excludeItems = PlacesUtils.annotations.getItemsWithAnnotation(PlacesUtils.EXCLUDE_FROM_BACKUP_ANNO);
			let options = PlacesUtils.history.getNewQueryOptions();
			options.expandQueries = false;
			let query = PlacesUtils.history.getNewQuery();
			query.setFolders([PlacesUtils.placesRootId], 1);
			let root = PlacesUtils.history.executeQuery(query, options).root;
			root.containerOpen = true;
			// --------------------------------------------------
			// Replace PlacesUtils.serializeNodeAsJSONToOutputStream(root, streamProxy, false, false, excludeItems);
			// --------------------------------------------------
				// From https://bugzilla.mozilla.org/show_bug.cgi?id=854761
				// This function will be deprecated and use asynchronous BookmarkNode.serializeAsJSONToOutputStream instead
				// But in comment 6 say that some internal code still need synchronous function which will change name by add prefix _
				PlacesUtils._serializeNodeAsJSONToOutputStream(root, streamProxy, false, false, excludeItems);
			// --------------------------------------------------
			// End Replace PlacesUtils.serializeNodeAsJSONToOutputStream(root, streamProxy, false, false, excludeItems);
			// --------------------------------------------------
			root.containerOpen = false;
			converter.close();
			stream.close();
		// --------------------------------------------------
		// End Replace this._writeBackupFile(aFile);
		// --------------------------------------------------
		if (aFile.parent.equals(this.folder)) {
			this.entries.push(aFile);
		} else {
			var latestBackup = this.getMostRecent("json");
			if (!latestBackup || latestBackup != aFile) {
				let name = this.getFilenameForDate();
				let file = this.folder.clone();
				file.append(name);
				if (file.exists()) {
					file.remove(false);
				} else {
					this.entries.push(file);
				}
				aFile.copyTo(this.folder, name);
			}
		}
	},
	//===================================================================================
	//  Gecko 25 Patch function - PlacesBackups.saveBookmarksToJSONFile
	//		Using nodeCount as a signal that annotation collection for JSON is finished
	//===================================================================================
	taskWait: false,
	taskException: null,
	taskResult: null,
	saveBookmarksToJSONFileForGecko25: function() {
		Components.utils.import("resource://gre/modules/Task.jsm");
		bookmarkfaviconchangerModule.taskWait = true;
		Task.spawn(function () {
			let nodeCount = yield bookmarkfaviconchangerModule.saveBookmarksToJSONFile.apply(bookmarkfaviconchangerModule.saveBookmarksToJSONFileThis, bookmarkfaviconchangerModule.saveBookmarksToJSONFileArguments);
			throw new Task.Result(nodeCount);
		}).then(function (result) {
			bookmarkfaviconchangerModule.taskException = false;
			bookmarkfaviconchangerModule.taskResult = result;
			bookmarkfaviconchangerModule.taskWait = false;
		}, function (exception) {
			bookmarkfaviconchangerModule.taskException = true;
			bookmarkfaviconchangerModule.taskResult = exception;
			bookmarkfaviconchangerModule.taskWait = false;
		});
		var currentThread = bookmarkfaviconchangerModule.threadService.currentThread;
		while (bookmarkfaviconchangerModule.taskWait) { currentThread.processNextEvent(true); }
		if (bookmarkfaviconchangerModule.taskException) {
			throw bookmarkfaviconchangerModule.taskResult;
		} else {
			return bookmarkfaviconchangerModule.taskResult;
		}
	},
	//===================================================================================
	//  Gecko 36 Patch function - PlacesUtils.nodeIsReadOnly is not exist anymore
	//===================================================================================
	nodeIsReadOnly: function(selectedNode) {
		Components.utils.import("resource://gre/modules/PlacesUtils.jsm");
		try {
			return PlacesUtils.nodeIsReadOnly(selectedNode);
		} catch(e) {
			return false;
		}
	}
}
