//================================================================
// Bookmark Favicon Changer by Sonthakit Leelahanon.
// Copyright 2016 Sonthakit Leelahanon. All rights reserved.
//================================================================

var bookmarkfaviconchangerOptions = {
	pageFaviconDataURISpecNS: "bookmarkfaviconchanger/faviconDataURISpec",	 // version >= 1.60 (not use in export and json backup, what you see is what you get policy)
	pageOriginalFaviconURISpecNS: "bookmarkfaviconchanger/faviconurispec",	 // Real NS is inherited, not good meaning, but do no change for forward compatibility
	itemFolderFaviconDataURISpecNS: "bookmarkfaviconchanger/faviconurispec", // Real NS is inherited, not good meaning, but do no change for forward compatibility
	itemJsonFolderFaviconDataURISpecNS: "bookmarkfaviconchanger/folderFaviconDataURISpec",
	itemJsonFaviconDataURISpecNS: "bookmarkfaviconchanger/faviconDataURISpec",
	itemJsonOriginalFaviconURISpecNS: "bookmarkfaviconchanger/originalFaviconURISpec",
	localDefaultFolder: null,
	localDefaultFolderValid: true,
	init: function() {
		Components.utils.import("chrome://bookmarkfaviconchanger/content/module.jsm");
		bookmarkfaviconchangerModule.init();
		if (bookmarkfaviconchangerModule.runtimeService.OS=="Darwin") {
			document.getElementById("bookmarkfaviconchangerOptions-chooseFolderWin").hidden = true;
			document.getElementById("bookmarkfaviconchangerOptions-chooseFolderMac").hidden = false;
		} else {	// Linux and WINNT
			document.getElementById("bookmarkfaviconchangerOptions-chooseFolderWin").hidden = false;
			document.getElementById("bookmarkfaviconchangerOptions-chooseFolderMac").hidden = true;
		}
		try {
			this.localDefaultFolder = bookmarkfaviconchangerModule.branch.getComplexValue("defaultFolder", Components.interfaces.nsILocalFile);
			document.getElementById("bookmarkfaviconchangerOptions-defaultFolderTextBox").value = this.localDefaultFolder.path;
		} catch(e) {
			this.localDefaultFolderValid = false;
			var charDefaultFolder = "";
			try {
				charDefaultFolder = bookmarkfaviconchangerModule.branch.getCharPref("defaultFolder")
			} catch(e) {
			}
			document.getElementById("bookmarkfaviconchangerOptions-defaultFolderTextBox").value = charDefaultFolder;
		}
	},
	about: function() {
		window.openDialog("chrome://bookmarkfaviconchanger/content/about.xul","","chrome,titilebar,centerscreen,dialog=yes");
	},
	feedback: function() {
		var targetURL = "https://sites.google.com/site/sonthakit/bookmarkfaviconchanger";
		var recentWindow = bookmarkfaviconchangerModule.mediatorService.getMostRecentWindow("navigator:browser");
		if (recentWindow) {
			var urlbarValue = recentWindow.document.getElementById("urlbar").value;
			urlbarValue = urlbarValue.replace(/^\s+|\s+$/g, "");
			if (urlbarValue.length) {
				recentWindow.gBrowser.loadOneTab(targetURL,null,null,null,false,null);
			} else {
				recentWindow.loadURI(targetURL);
			}
		} else {
			recentWindow = bookmarkfaviconchangerModule.mediatorService.getMostRecentWindow(null);
			recentWindow.open(targetURL);
		}
	},
	defaultFolderChange: function() {
		if (Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBoolPref("browser.preferences.instantApply")) {
			this.saveDefaultFolder();
		}
	},
	browseDefaultFolder: function() {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, document.getElementById("bookmarkfaviconchangerOptions-defaultFolderCaption").label, nsIFilePicker.modeGetFolder);
		fp.displayDirectory = bookmarkfaviconchangerModule.getDefaultDirectory();
		if (fp.show() == nsIFilePicker.returnOK) {
			this.localDefaultFolder = fp.file;
			this.localDefaultFolderValid = true;
			document.getElementById("bookmarkfaviconchangerOptions-defaultFolderTextBox").value = this.localDefaultFolder.path;
			if (Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBoolPref("browser.preferences.instantApply")) {
				this.saveDefaultFolder();
			}
		}
	},
	saveDefaultFolder: function() {
		var newDefaultFolder = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		var textDefaultFolder = document.getElementById("bookmarkfaviconchangerOptions-defaultFolderTextBox").value;
		textDefaultFolder = textDefaultFolder.replace(/^\s+|\s+$/g, "");
		try {
			if (this.localDefaultFolderValid) {
				if (this.localDefaultFolder.path == textDefaultFolder) {
					bookmarkfaviconchangerModule.branch.setComplexValue("defaultFolder", Components.interfaces.nsILocalFile, this.localDefaultFolder);
				} else {
					newDefaultFolder.initWithPath(textDefaultFolder);
					bookmarkfaviconchangerModule.branch.setComplexValue("defaultFolder", Components.interfaces.nsILocalFile, newDefaultFolder);
				}
			} else {
				newDefaultFolder.initWithPath(textDefaultFolder);
				bookmarkfaviconchangerModule.branch.setComplexValue("defaultFolder", Components.interfaces.nsILocalFile, newDefaultFolder);
			}
		} catch(e) {
			bookmarkfaviconchangerModule.branch.setCharPref("defaultFolder", textDefaultFolder);
		}
	},
	resetAllCustomFavicon: function() {
		var result = bookmarkfaviconchangerModule.promptService.confirmEx(null, "Bookmark Favicon Changer"
			,bookmarkfaviconchangerModule.bundle.GetStringFromName("resetConfirm")
			,16778243,null,null,null,null,{value: false});		// 16778243=(3*1)+(4*256)+16777216 - see https://developer.mozilla.org/en/nsIPromptService
		if (result==0) {
			bookmarkfaviconchangerModule.lockCSS = true;
			bookmarkfaviconchangerModule.destroyAnnotation(true);
			bookmarkfaviconchangerModule.lockCSS = false;
			bookmarkfaviconchangerModule.changeCSS();
		}
	},
	exportAllCustomFavicon: function() {
		bookmarkfaviconchangerModule.purgeAnnotation();
		// bookmarkfaviconchangerModule.destroyOrphanAnnotation();		// No need to do this at this time, let's do it at browser quit
		var uris = bookmarkfaviconchangerModule.annotationService.getPagesWithAnnotation(this.pageOriginalFaviconURISpecNS);
		var items = bookmarkfaviconchangerModule.annotationService.getItemsWithAnnotation(this.itemFolderFaviconDataURISpecNS);
		if ((uris.length==0) && (items.length==0)) {
			bookmarkfaviconchangerModule.promptService.alert(null, "Bookmark Favicon Changer"
				,bookmarkfaviconchangerModule.bundle.GetStringFromName("noCustomFaviconFound"));
		} else {
			var nsIFilePicker = Components.interfaces.nsIFilePicker;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			fp.init(window, document.getElementById("bookmarkfaviconchangerOptions-exportAllcustomFavicon").label, nsIFilePicker.modeSave);
			fp.displayDirectory = bookmarkfaviconchangerModule.getDefaultDirectory();
			fp.appendFilter("Zip Files (zip)","*.zip");
			fp.appendFilters(nsIFilePicker.filterAll);
			fp.defaultString = "favicon.zip";
			fp.defaultExtension = "zip";
			var fpResult = fp.show();
			if ((fpResult == nsIFilePicker.returnOK) || (fpResult == nsIFilePicker.returnReplace)) {
				var zipWriter = Components.classes["@mozilla.org/zipwriter;1"].createInstance(Components.interfaces.nsIZipWriter);
				zipWriter.open(fp.file, 0x2A);      // PR_WRITE_ONLY | PR_CREATE_FILE | PR_TRUNCATE);
				var thisTime=(new Date()).getTime();
				var fileCount = 1;
				Components.utils.import("resource://gre/modules/NetUtil.jsm");
				for (var i = 0; i < uris.length; i++) {
					try {
						try {
							var faviconURI = bookmarkfaviconchangerModule.getFaviconForPage(uris[i]);
						} catch(e) {
							var faviconURI = bookmarkfaviconchangerModule.getFaviconImageForPage(uris[i]);
						}
						// for safety, don't expect faviconURI as data : png because other addon may destroy it
						var faviconDataURISpec = bookmarkfaviconchangerModule.getFaviconDataAsDataURL(uris[i], faviconURI);
						if (faviconDataURISpec != null) {
							var faviconDataURI = bookmarkfaviconchangerModule.ioService.newURI(faviconDataURISpec, null, null);
							var result = bookmarkfaviconchangerModule.getImageTypeFromURI(faviconDataURI,faviconDataURISpec);
							var defaultFileExtension = result[0];
							if (defaultFileExtension != "") {
								var faviconDataURIChannel = NetUtil.newChannel(faviconDataURI);
								zipWriter.addEntryChannel(fileCount+"."+defaultFileExtension, thisTime*1000, 9, faviconDataURIChannel, false);	// 9=COMPRESSION_BEST
							}
						}
					} catch(e) {
					}
					fileCount++;
				}
				for (var i = 0; i < items.length; i++) {
					try {
						var folderFaviconDataURISpec = bookmarkfaviconchangerModule.annotationService.getItemAnnotation(items[i],this.itemFolderFaviconDataURISpecNS);
						var folderFaviconDataURI = bookmarkfaviconchangerModule.ioService.newURI(folderFaviconDataURISpec, null, null);
						var folderFaviconDataURIChannel = NetUtil.newChannel(folderFaviconDataURI);
						zipWriter.addEntryChannel(fileCount+".png", thisTime*1000, 9, folderFaviconDataURIChannel, false);	// 9=COMPRESSION_BEST
					} catch(e) {
					}
					fileCount++;
				}
				zipWriter.close();
			}
		}
	},
	accept: function() {
		this.saveDefaultFolder();
		return true;
	}
}