//================================================================
// Bookmark Favicon Changer by Sonthakit Leelahanon.
// Copyright 2016 Sonthakit Leelahanon. All rights reserved.
//================================================================

var bookmarkfaviconchangerPlacesContext = {
	popupEventListening: false,
	targetNode: null,
	targetNodes: null,
	popupStatus: 0,
	popupShowing: function(event) {
		if (this.popupStatus == 0) {
			if (event.target.id == "placesContext") {
				placesContext = event.target;
				var selectedNode = PlacesUIUtils.getViewForNode(document.popupNode).selectedNode;
				// ref chrome://browser/content/places/placesOverlay.xul, placesContext, onpopupshowing : this._view = PlacesUIUtils.getViewForNode(document.popupNode)
				// ref chrome://browser/content/places/controller.js, showBookmarkPropertiesForSelection() : var node = this._view.selectedNode;
				if (selectedNode) {										// multiple node selection make this false
					if (PlacesUtils.nodeIsBookmark(selectedNode)) {		// Before FF 13 - LivemarkItem is also Bookmark. From FF 13, it is not.
						this.makePopupMenu(0,true,true,true,true);
						this.targetNode = selectedNode;
					} else if (PlacesUtils.nodeIsFolder(selectedNode)) {	// LivemarkContainer is also a folder and readonly - it is include in here
						var itemId = selectedNode.itemId;
						if (bookmarkfaviconchangerModule.geckoBefore13) {
							var thisFolderIsLivemarkContainer = PlacesUtils.nodeIsLivemarkContainer(selectedNode);
						} else {
							// From Gecko 13, nodeIsLivemarkContainer is mark as deprecated.
							// New method in Gecko 13 (ref resource://gre/modules/PlacesUtils.jsm) use nodeIsFolder + itemIsLivemark
							// While itemIsLivemark use item annotation "livemark/feedURI" or function "isLivemark" to be a marker of livemark
							// And isLivemark still also use item annotation "livemark/feedURI" to identified
							var thisFolderIsLivemarkContainer = true;
							try {
								var livemarkFeedURI = bookmarkfaviconchangerModule.annotationService.getItemAnnotation(itemId,"livemark/feedURI");
							} catch(e) {
								thisFolderIsLivemarkContainer = false;
							}
						}
						// Filter out readonly folder that is not livemark container (such as "All Bookmarks" in bookmark manager)
						if (thisFolderIsLivemarkContainer || (!bookmarkfaviconchangerModule.nodeIsReadOnly(selectedNode))) {
							if (bookmarkfaviconchangerModule.isUsableItemId(itemId)) {
								try {
									var faviconURISpec = bookmarkfaviconchangerModule.annotationService.getItemAnnotation(itemId
										,bookmarkfaviconchangerModule.itemFolderFaviconDataURISpecNS);
									// no reset for folder, folder only can remove
									this.makePopupMenu(8,true,false,true,true);
								} catch(e) {
									// this folder do not have custom favicon, so it cannot remove favicon and export favicon
									this.makePopupMenu(8,true,false,false,false);
								}
								this.targetNode = selectedNode;
							}
						}
					}
				} else {	// multiple selection
					var selectedNodes = PlacesUIUtils.getViewForNode(document.popupNode).selectedNodes;
					if (selectedNodes) {
						// finding what menu should apppear - using AND protocol
						var showReset = true;
						var showRemove = true;
						var showExport = true;
						var allNodesAreUsable = true;
						for (var i = 0; i < selectedNodes.length; i++) {
							var selectedNode = selectedNodes[i];
							if (PlacesUtils.nodeIsBookmark(selectedNode)) {		// Before FF 13 - LivemarkItem is also Bookmark. From FF 13, it is not.
								// no action
							} else if (PlacesUtils.nodeIsFolder(selectedNode)) {	// LivemarkContainer is also a folder and readonly - it is include in here
								var itemId = selectedNode.itemId;
								if (bookmarkfaviconchangerModule.geckoBefore13) {
									var thisFolderIsLivemarkContainer = PlacesUtils.nodeIsLivemarkContainer(selectedNode);
								} else {
									// From Gecko 13, nodeIsLivemarkContainer is mark as deprecated.
									// New method in Gecko 13 (ref resource://gre/modules/PlacesUtils.jsm) use nodeIsFolder + itemIsLivemark
									// While itemIsLivemark use item annotation "livemark/feedURI" or function "isLivemark" to be a marker of livemark
									// And isLivemark still also use item annotation "livemark/feedURI" to identified
									var thisFolderIsLivemarkContainer = true;
									try {
										var livemarkFeedURI = bookmarkfaviconchangerModule.annotationService.getItemAnnotation(itemId,"livemark/feedURI");
									} catch(e) {
										thisFolderIsLivemarkContainer = false;
									}
								}
								// Filter out readonly folder that is not livemark container (such as "All Bookmarks" in bookmark manager)
								if (thisFolderIsLivemarkContainer || (!bookmarkfaviconchangerModule.nodeIsReadOnly(selectedNode))) {
									if (bookmarkfaviconchangerModule.isUsableItemId(itemId)) {
										try {
											var faviconURISpec = bookmarkfaviconchangerModule.annotationService.getItemAnnotation(itemId
												,bookmarkfaviconchangerModule.itemFolderFaviconDataURISpecNS);
											showReset = false;
										} catch(e) {
											// this folder do not have custom favicon, so it cannot remove favicon and export favicon
											showReset = false;
											showRemove = false;
											showExport = false;
										}
									} else {	// this node cannot use
										allNodesAreUsable = false;
										break;
									}
								} else {	// this node cannot use
									allNodesAreUsable = false;
									break;
								}
							}
						}
						if (allNodesAreUsable) {		// accept possibility that all menu are gray
							this.makePopupMenu(16,false,showReset,showRemove,showExport);
							this.targetNodes = selectedNodes;
						}
					}
				}
			}
		}
		return true;
	},
	makePopupMenu: function(mode, enbleChange, enableReset, enableRemove, enableExport) {
		// mode 0 = bookmark, mode 8 = folder, mode 16 = multiple
		var elementChangeFavicon = document.createElement("menuitem");
		var elementResetFavicon = document.createElement("menuitem");
		var elementRemoveFavicon = document.createElement("menuitem");
		var elementExportFavicon = document.createElement("menuitem");
		var elementMenuSeparator = document.createElement("menuseparator");
		elementChangeFavicon.setAttribute("id", "bookmarkfaviconchanger-changeFavicon");
		elementResetFavicon.setAttribute("id", "bookmarkfaviconchanger-resetFavicon");
		elementRemoveFavicon.setAttribute("id", "bookmarkfaviconchanger-removeFavicon");
		elementExportFavicon.setAttribute("id", "bookmarkfaviconchanger-exportFavicon");
		elementMenuSeparator.setAttribute("id", "bookmarkfaviconchanger-menuSeparator");
		elementChangeFavicon.setAttribute("label", bookmarkfaviconchangerModule.bundle.GetStringFromName("changeFavicon"));
		elementResetFavicon.setAttribute("label", bookmarkfaviconchangerModule.bundle.GetStringFromName("resetFavicon"));
		elementRemoveFavicon.setAttribute("label", bookmarkfaviconchangerModule.bundle.GetStringFromName("removeFavicon"));
		elementExportFavicon.setAttribute("label", bookmarkfaviconchangerModule.bundle.GetStringFromName("exportFavicon"));
		var elementProperties = document.getElementById("placesContext_show:info");
		var menuHasPropertiesItemShow = false;
		if (elementProperties) {
			menuHasPropertiesItemShow = true;
			if (elementProperties.hasAttribute("hidden")) {
				if (elementProperties.getAttribute("hidden")) {
					menuHasPropertiesItemShow = false;
				}
			}
		}
		if (bookmarkfaviconchangerModule.branch.getBoolPref("compactContextMenu")) {
			var elementMenu = document.createElement("menu");
			var elementMenuPopup = document.createElement("menupopup");
			elementMenu.setAttribute("id", "bookmarkfaviconchanger-menu");
			elementMenuPopup.setAttribute("id", "bookmarkfaviconchanger-menuPopup");
			elementMenu.setAttribute("label", bookmarkfaviconchangerModule.bundle.GetStringFromName("favicon"));
			if (menuHasPropertiesItemShow) {
				placesContext.insertBefore(elementMenu,elementProperties);
				this.popupStatus = 5;		// 4+1
			} else {
				placesContext.appendChild(elementMenuSeparator);
				placesContext.appendChild(elementMenu);
				this.popupStatus = 7;		// 4+2+1
			}
			elementMenu.appendChild(elementMenuPopup);
			elementMenuPopup.appendChild(elementChangeFavicon);
			elementMenuPopup.appendChild(elementResetFavicon);
			elementMenuPopup.appendChild(elementRemoveFavicon);
			elementMenuPopup.appendChild(elementExportFavicon);
			elementMenuPopup.addEventListener("popupshowing", function(event){event.stopPropagation();}, false);
			elementMenuPopup.addEventListener("popupshown", function(event){event.stopPropagation();}, false);
			elementMenuPopup.addEventListener("popuphiding", function(event){event.stopPropagation();}, false);
			elementMenuPopup.addEventListener("popuphidden", function(event){event.stopPropagation();}, false);
		} else {
			if (menuHasPropertiesItemShow) {
				placesContext.insertBefore(elementChangeFavicon,elementProperties);
				placesContext.insertBefore(elementResetFavicon,elementProperties);
				placesContext.insertBefore(elementRemoveFavicon,elementProperties);
				placesContext.insertBefore(elementExportFavicon,elementProperties);
				placesContext.insertBefore(elementMenuSeparator,elementProperties);
				this.popupStatus = 3;		// 2+1;
			} else {
				placesContext.appendChild(elementMenuSeparator);
				placesContext.appendChild(elementChangeFavicon);
				placesContext.appendChild(elementResetFavicon);
				placesContext.appendChild(elementRemoveFavicon);
				placesContext.appendChild(elementExportFavicon);
				this.popupStatus = 3;		// 2+1;
			}
		}
		this.popupStatus += mode;
		if (mode == 0) {
			elementChangeFavicon.addEventListener("command",function(){bookmarkfaviconchangerPlacesContext.changeFavicon();}, false);
			elementResetFavicon.addEventListener("command",function(){bookmarkfaviconchangerPlacesContext.resetFavicon();}, false);
			elementRemoveFavicon.addEventListener("command",function(){bookmarkfaviconchangerPlacesContext.useDefaultFavicon();}, false);
			elementExportFavicon.addEventListener("command",function(){bookmarkfaviconchangerPlacesContext.exportFavicon();}, false);
		} else if (mode == 8) {
			elementChangeFavicon.addEventListener("command",function(){bookmarkfaviconchangerPlacesContext.changeFaviconForFolder();}, false);
			elementRemoveFavicon.addEventListener("command",function(){bookmarkfaviconchangerPlacesContext.useDefaultFaviconForFolder();}, false);
			elementExportFavicon.addEventListener("command",function(){bookmarkfaviconchangerPlacesContext.exportFaviconForFolder();}, false);
		} else {	// mode 16
			elementResetFavicon.addEventListener("command",function(){bookmarkfaviconchangerPlacesContext.resetFaviconMultiple();}, false);
			elementRemoveFavicon.addEventListener("command",function(){bookmarkfaviconchangerPlacesContext.useDefaultFaviconMultiple();}, false);
			elementExportFavicon.addEventListener("command",function(){bookmarkfaviconchangerPlacesContext.exportFaviconMultiple();}, false);
		}
		if (!enbleChange) {elementChangeFavicon.setAttribute("disabled", true);}
		if (!enableReset) {elementResetFavicon.setAttribute("disabled", true);}
		if (!enableRemove) {elementRemoveFavicon.setAttribute("disabled", true);}
		if (!enableExport) {elementExportFavicon.setAttribute("disabled", true);}
	},
	popupHiding: function(event) {
		if (this.popupStatus != 0) {
			if (event.target.id == "placesContext") {
				placesContext = event.target;
				var elementChangeFavicon = document.getElementById("bookmarkfaviconchanger-changeFavicon");
				var elementResetFavicon = document.getElementById("bookmarkfaviconchanger-resetFavicon");
				var elementRemoveFavicon = document.getElementById("bookmarkfaviconchanger-removeFavicon");
				var elementExportFavicon = document.getElementById("bookmarkfaviconchanger-exportFavicon");
				if (this.popupStatus < 8) {
					elementChangeFavicon.removeEventListener("command",function(){bookmarkfaviconchangerPlacesContext.changeFavicon();}, false);
					elementResetFavicon.removeEventListener("command",function(){bookmarkfaviconchangerPlacesContext.resetFavicon();}, false);
					elementRemoveFavicon.removeEventListener("command",function(){bookmarkfaviconchangerPlacesContext.useDefaultFavicon();}, false);
					elementExportFavicon.removeEventListener("command",function(){bookmarkfaviconchangerPlacesContext.exportFavicon();}, false);
				} else if (this.popupStatus < 16) {
					this.popupStatus -= 8;
					elementChangeFavicon.removeEventListener("command",function(){bookmarkfaviconchangerPlacesContext.changeFaviconForFolder();}, false);
					elementRemoveFavicon.removeEventListener("command",function(){bookmarkfaviconchangerPlacesContext.useDefaultFaviconForFolder();}, false);
					elementExportFavicon.removeEventListener("command",function(){bookmarkfaviconchangerPlacesContext.exportFaviconForFolder();}, false);
				} else {
					this.popupStatus -= 16;
					elementResetFavicon.removeEventListener("command",function(){bookmarkfaviconchangerPlacesContext.resetFaviconMultiple();}, false);
					elementRemoveFavicon.removeEventListener("command",function(){bookmarkfaviconchangerPlacesContext.useDefaultFaviconMultiple();}, false);
					elementExportFavicon.removeEventListener("command",function(){bookmarkfaviconchangerPlacesContext.exportFaviconMultiple();}, false);
				}
				if (this.popupStatus >= 4 ) {
					this.popupStatus -= 4;
					var elementMenu = document.getElementById("bookmarkfaviconchanger-menu");
					var elementMenuPopup = document.getElementById("bookmarkfaviconchanger-menuPopup");
					elementMenuPopup.removeEventListener("popupshowing", function(event){event.stopPropagation();}, false);
					elementMenuPopup.removeEventListener("popupshown", function(event){event.stopPropagation();}, false);
					elementMenuPopup.removeEventListener("popuphiding", function(event){event.stopPropagation();}, false);
					elementMenuPopup.removeEventListener("popuphidden", function(event){event.stopPropagation();}, false);
					elementMenuPopup.removeChild(elementChangeFavicon);
					elementMenuPopup.removeChild(elementResetFavicon);
					elementMenuPopup.removeChild(elementRemoveFavicon);
					elementMenuPopup.removeChild(elementExportFavicon);
					elementMenu.removeChild(elementMenuPopup);
					placesContext.removeChild(elementMenu);
				} else {
					placesContext.removeChild(elementChangeFavicon);
					placesContext.removeChild(elementResetFavicon);
					placesContext.removeChild(elementRemoveFavicon);
					placesContext.removeChild(elementExportFavicon);
				}
				if (this.popupStatus >=2 ) {
					this.popupStatus -= 2;
					var elementMenuSeparator = document.getElementById("bookmarkfaviconchanger-menuSeparator");
					placesContext.removeChild(elementMenuSeparator);
				}
				this.popupStatus = 0;
				// this.targetNode = null;	// don't do this, menu is collapse before function execute
				// this.targetNodes = null;	// don't do this, menu is collapse before function execute
			}
		}
	},
	changeFavicon: function() {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, bookmarkfaviconchangerModule.bundle.GetStringFromName("changeFavicon"), nsIFilePicker.modeOpen);
		fp.displayDirectory = bookmarkfaviconchangerModule.getDefaultDirectory();
		var filter = "*.ico; *.bmp; *.dib; *.gif; *.jpg; *.jpe; *.jpeg; *.jif; *.jfi; *.jfif; *.png; *.apng; *.svg";
		var filterTitle = bookmarkfaviconchangerModule.bundle.GetStringFromName("imageFiles") + " (" + filter + ")";
		fp.appendFilter(filterTitle,filter);
		fp.appendFilter("Icon File (*.ico)","*.ico");
		fp.appendFilter("Bitmap Image File (*.bmp; *.dib)","*.bmp; *.dib");
		fp.appendFilter("Graphics Interchange Format File (*.gif)","*.gif");
		fp.appendFilter("Joint Photographic Experts Group File (*.jpg; *.jpe; *.jpeg; *.jif; *.jfi; *.jfif)","*.jpg; *.jpe; *.jpeg; *.jif; *.jfi; *.jfif");
		fp.appendFilter("Portable Network Graphics File (*.png; *.apng)","*.png; *.apng");
		fp.appendFilter("Scalable Vector Graphics File (*.svg)","*.svg");
		fp.appendFilters(nsIFilePicker.filterAll);
		if (fp.show() == nsIFilePicker.returnOK) {
			try {
				var faviconURI = bookmarkfaviconchangerModule.ioService.newFileURI(fp.file);
			} catch(e) {
				return;
			}
			var img = new Image();
			img.onload = function() {
				var imgWidth = img.width;
				var imgHeight = img.height;
				if ((imgWidth > 16) || (imgHeight > 16)) {
					var resizeRatio = 16/(Math.max(imgWidth,imgHeight));
					imgWidth = Math.max(1,Math.round(imgWidth*resizeRatio));
					imgHeight = Math.max(1,Math.round(imgHeight*resizeRatio));
				}
				var canvas = document.createElementNS ("http://www.w3.org/1999/xhtml", "canvas");
				canvas.setAttribute("width", 16);
				canvas.setAttribute("height", 16);
				var ctx = canvas.getContext("2d");
				ctx.clearRect (0, 0, 16, 16);
				ctx.drawImage(img, Math.ceil((16-imgWidth)/2), Math.ceil((16-imgHeight)/2), imgWidth, imgHeight);
				var faviconDataURISpec = canvas.toDataURL("image/png", "");
				var faviconDataURI = bookmarkfaviconchangerModule.ioService.newURI(faviconDataURISpec, null, null);
				try {
					var bookmarkURI = PlacesUtils.bookmarks.getBookmarkURI(bookmarkfaviconchangerPlacesContext.targetNode.itemId);
					try {
						var originalFaviconURISpec = bookmarkfaviconchangerModule.annotationService.getPageAnnotation(bookmarkURI
							,bookmarkfaviconchangerModule.pageOriginalFaviconURISpecNS);
					} catch(e) {
						try {
							var originalFaviconURISpec = bookmarkfaviconchangerModule.getFaviconForPage(bookmarkURI).spec;
						} catch(e) {
							var originalFaviconURISpec = bookmarkfaviconchangerModule.getFaviconImageForPage(bookmarkURI).spec;
							if (bookmarkfaviconchangerModule.geckoBefore13) {
								// this function not return the correct URIspec for default livemark item, so modified it again
								if (PlacesUtils.nodeIsLivemarkItem(bookmarkfaviconchangerPlacesContext.targetNode)) {
									if (originalFaviconURISpec == bookmarkfaviconchangerModule.defaultFaviconURISpec) {
										originalFaviconURISpec = bookmarkfaviconchangerModule.livemarkItemFaviconURISpec;
									}
								}
							}
						}
						bookmarkfaviconchangerModule.annotationService.setPageAnnotation(bookmarkURI
							,bookmarkfaviconchangerModule.pageOriginalFaviconURISpecNS,originalFaviconURISpec,0,4);
					}
					bookmarkfaviconchangerModule.annotationService.setPageAnnotation(bookmarkURI,bookmarkfaviconchangerModule.pageFaviconDataURISpecNS
						,faviconDataURISpec,0,4);
					bookmarkfaviconchangerModule.setAndLoadFaviconForPage(bookmarkURI,faviconDataURI,true,null);
				} catch(e) {
				}
			};
			img.src = faviconURI.spec;
		}
	},
	resetFavicon: function() {
		try {
			var bookmarkURI = PlacesUtils.bookmarks.getBookmarkURI(this.targetNode.itemId);
			try {
				var originalFaviconURISpec = bookmarkfaviconchangerModule.annotationService.getPageAnnotation(bookmarkURI
					,bookmarkfaviconchangerModule.pageOriginalFaviconURISpecNS);
				var originalFaviconURI = bookmarkfaviconchangerModule.ioService.newURI(originalFaviconURISpec, null, null);
				bookmarkfaviconchangerModule.annotationService.removePageAnnotation(bookmarkURI,bookmarkfaviconchangerModule.pageOriginalFaviconURISpecNS);
				try {
					bookmarkfaviconchangerModule.annotationService.removePageAnnotation(bookmarkURI,bookmarkfaviconchangerModule.pageFaviconDataURISpecNS);
				} catch(e) {
				}
				bookmarkfaviconchangerModule.setAndLoadFaviconForPage(bookmarkURI,originalFaviconURI,true,null);
			} catch(e) {
				try {
					var originalFaviconURISpec = bookmarkURI.prePath + "/favicon.ico";
					var originalFaviconURI = bookmarkfaviconchangerModule.ioService.newURI(originalFaviconURISpec, null, null);
					bookmarkfaviconchangerModule.setAndLoadFaviconForPage(bookmarkURI,originalFaviconURI,true,null);
				} catch(e) {
					this.useDefaultFavicon();
				}
			}
		} catch(e) {
		}
	},
	useDefaultFavicon: function() {
		try {
			var bookmarkURI = PlacesUtils.bookmarks.getBookmarkURI(this.targetNode.itemId);
			try {
				bookmarkfaviconchangerModule.annotationService.removePageAnnotation(bookmarkURI,bookmarkfaviconchangerModule.pageOriginalFaviconURISpecNS);
				bookmarkfaviconchangerModule.annotationService.removePageAnnotation(bookmarkURI,bookmarkfaviconchangerModule.pageFaviconDataURISpecNS);
			} catch(e) {
			}
			if (bookmarkfaviconchangerModule.geckoBefore13) {
				if (PlacesUtils.nodeIsLivemarkItem(this.targetNode)) {
					try {
						bookmarkfaviconchangerModule.setAndLoadFaviconForPage(bookmarkURI,bookmarkfaviconchangerModule.livemarkItemFaviconURI,true,null);
					} catch(e) {
						try {
							bookmarkfaviconchangerModule.setAndLoadFaviconForPage(bookmarkURI,bookmarkfaviconchangerModule.defaultFaviconURI,true,null);
						} catch(e) {
						}
					}
				} else {
					try {
						bookmarkfaviconchangerModule.setAndLoadFaviconForPage(bookmarkURI,bookmarkfaviconchangerModule.defaultFaviconURI,true,null);
					} catch(e) {
					}
				}
			} else {		//gecko13+
				try {
					bookmarkfaviconchangerModule.setAndLoadFaviconForPage(bookmarkURI,bookmarkfaviconchangerModule.defaultFaviconURI,true,null);
				} catch(e) {
				}
			}
		} catch(e) {
		}
	},
	exportFavicon: function() {
		try {
			var bookmarkURI = PlacesUtils.bookmarks.getBookmarkURI(this.targetNode.itemId);
			try {
				var faviconURI = bookmarkfaviconchangerModule.getFaviconForPage(bookmarkURI);
				var faviconURISpec = faviconURI.spec;
				try {
					// try to use off-line data first
					var faviconDataURISpec = bookmarkfaviconchangerModule.getFaviconDataAsDataURL(bookmarkURI, faviconURI);
					if (faviconDataURISpec != null) {
						faviconURISpec = faviconDataURISpec;
						faviconURI = bookmarkfaviconchangerModule.ioService.newURI(faviconURISpec, null, null);
					}
				} catch(e) {
				}
			} catch(e) {
				var faviconURI = bookmarkfaviconchangerModule.getFaviconImageForPage(bookmarkURI);
				var faviconURISpec = faviconURI.spec;
				if (bookmarkfaviconchangerModule.geckoBefore13) {
					// this function not return the correct URI for default livefeed item, so modified it again
					if (PlacesUtils.nodeIsLivemarkItem(this.targetNode)) {
						if (faviconURISpec == bookmarkfaviconchangerModule.defaultFaviconURISpec) {
							faviconURI = bookmarkfaviconchangerModule.livemarkItemFaviconURI;
							faviconURISpec = bookmarkfaviconchangerModule.livemarkItemFaviconURISpec;
						}
					}
				}
			}
			this.exportFaviconToFile(faviconURI,faviconURISpec);
		} catch(e) {
			throw e;
		}
	},
	changeFaviconForFolder: function() {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, bookmarkfaviconchangerModule.bundle.GetStringFromName("changeFavicon"), nsIFilePicker.modeOpen);
		fp.displayDirectory = bookmarkfaviconchangerModule.getDefaultDirectory();
		var filter = "*.ico; *.bmp; *.dib; *.gif; *.jpg; *.jpe; *.jpeg; *.jif; *.jfi; *.jfif; *.png; *.apng; *.svg";
		var filterTitle = bookmarkfaviconchangerModule.bundle.GetStringFromName("imageFiles") + " (" + filter + ")";
		fp.appendFilter(filterTitle,filter);
		fp.appendFilter("Icon File (*.ico)","*.ico");
		fp.appendFilter("Bitmap Image File (*.bmp; *.dib)","*.bmp; *.dib");
		fp.appendFilter("Graphics Interchange Format File (*.gif)","*.gif");
		fp.appendFilter("Joint Photographic Experts Group File (*.jpg; *.jpe; *.jpeg; *.jif; *.jfi; *.jfif)","*.jpg; *.jpe; *.jpeg; *.jif; *.jfi; *.jfif");
		fp.appendFilter("Portable Network Graphics File (*.png; *.apng)","*.png; *.apng");
		fp.appendFilter("Scalable Vector Graphics File (*.svg)","*.svg");
		fp.appendFilters(nsIFilePicker.filterAll);
		if (fp.show() == nsIFilePicker.returnOK) {
			try {
				var faviconURI = bookmarkfaviconchangerModule.ioService.newFileURI(fp.file);
			} catch(e) {
				return;
			}
			var img = new Image();
			img.onload = function() {
				var imgWidth = img.width;
				var imgHeight = img.height;
				if ((imgWidth > 16) || (imgHeight > 16)) {
					var resizeRatio = 16/(Math.max(imgWidth,imgHeight));
					imgWidth = Math.max(1,Math.round(imgWidth*resizeRatio));
					imgHeight = Math.max(1,Math.round(imgHeight*resizeRatio));
				}
				var canvas = document.createElementNS ("http://www.w3.org/1999/xhtml", "canvas");
				canvas.setAttribute("width", 16);
				canvas.setAttribute("height", 16);
				var ctx = canvas.getContext("2d");
				ctx.clearRect (0, 0, 16, 16);
				ctx.drawImage(img, Math.ceil((16-imgWidth)/2), Math.ceil((16-imgHeight)/2), imgWidth, imgHeight);
				var faviconDataURISpec = canvas.toDataURL("image/png", "");
				var faviconDataURI = bookmarkfaviconchangerModule.ioService.newURI(faviconDataURISpec, null, null);
				try {
					bookmarkfaviconchangerModule.annotationService.setItemAnnotation(bookmarkfaviconchangerPlacesContext.targetNode.itemId
						,bookmarkfaviconchangerModule.itemFolderFaviconDataURISpecNS,faviconDataURISpec,0,4);
				} catch(e) {
				}
			};
			img.src = faviconURI.spec;
		}
	},
	useDefaultFaviconForFolder: function() {
		try {
			bookmarkfaviconchangerModule.annotationService.removeItemAnnotation(this.targetNode.itemId
				,bookmarkfaviconchangerModule.itemFolderFaviconDataURISpecNS);
		} catch(e) {
		}
	},
	exportFaviconForFolder: function() {
		// This function call only when folder have custom favicon
		try {
			var faviconDataURISpec = bookmarkfaviconchangerModule.annotationService.getItemAnnotation(this.targetNode.itemId
				,bookmarkfaviconchangerModule.itemFolderFaviconDataURISpecNS);
			var faviconDataURI = bookmarkfaviconchangerModule.ioService.newURI(faviconDataURISpec, null, null);
			this.exportFaviconToFile(faviconDataURI,faviconDataURISpec);
		} catch(e) {
		}
	},
	exportFaviconToFile: function(faviconURI, faviconURISpec) {
		// This function call in parent try-catch, no need to try-catch again
		var defaultFileName = bookmarkfaviconchangerModule.bookmarksService.getItemTitle(this.targetNode.itemId);
		if ((defaultFileName == "") || (defaultFileName == null)) {
			defaultFileName = "favicon";
		}
		var result = bookmarkfaviconchangerModule.getImageTypeFromURI(faviconURI,faviconURISpec);
		var defaultFileExtension = result[0];
		var filterTitle = result[1];
		var filter = result[2];
		if (defaultFileExtension != "") {
			var nsIFilePicker = Components.interfaces.nsIFilePicker;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			fp.init(window, bookmarkfaviconchangerModule.bundle.GetStringFromName("exportFavicon"), nsIFilePicker.modeSave);
			fp.displayDirectory = bookmarkfaviconchangerModule.getDefaultDirectory();
			fp.appendFilter(filterTitle,filter);
			fp.appendFilters(nsIFilePicker.filterAll);
			fp.defaultString = defaultFileName + "." + defaultFileExtension;
			fp.defaultExtension = defaultFileExtension;
			try {
				var fpResult = fp.show();
			} catch(e) {
				// This is for safety, possible error from weird filename (I still cannot get this error)
				fp.defaultString = "favicon." + defaultFileExtension;
				var fpResult = fp.show();
			}
			if ((fpResult == nsIFilePicker.returnOK) || (fpResult == nsIFilePicker.returnReplace)) {
				var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
				persist.persistFlags = 24608;  // =(32 + 8192 + 16384) Ref https://developer.mozilla.org/en/XPCOM_Interface_Reference/nsIWebBrowserPersist
				if (bookmarkfaviconchangerModule.geckoBefore18) {
					persist.saveURI(faviconURI, null, null, null, null, fp.file);
				} else {
					// Gecko 18+ need 7th parameter for private browsing = privacyContext
					try {
						var privacyContext = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
							.getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsILoadContext);
					} catch(e) {
						var privacyContext = null;
					}
					if (bookmarkfaviconchangerModule.geckoBefore36) {
						persist.saveURI(faviconURI, null, null, null, null, fp.file, privacyContext);
					} else {
						// Gecko 36+ add 8th parameter between parameter 3 and 4 = refererPolicy
						// nsiHttpChannel::REFERRER_POLICY_NO_REFERRER constant = 1
						var refererPolicy = 1;
						persist.saveURI(faviconURI, null, null, refererPolicy, null, null, fp.file, privacyContext);
					}
				}
			}
		} else {
			// unknown MIME type favicon, try to rescue situation by use canvas to download
			defaultFileExtension = "png";
			filterTitle = "Portable Network Graphics File (PNG)";
			filter = "*.png";
			var img = new Image();
			img.onload = function() {
				var imgWidth = img.width;
				var imgHeight = img.height;
				var canvas = window.document.createElementNS ("http://www.w3.org/1999/xhtml", "canvas");
				canvas.setAttribute("width", imgWidth);
				canvas.setAttribute("height", imgHeight);
				var ctx = canvas.getContext("2d");
				ctx.clearRect (0, 0, imgWidth, imgHeight);
				ctx.drawImage(img, 0, 0, imgWidth, imgHeight);
				var faviconDataURISpec = canvas.toDataURL("image/png", "");
				var faviconDataURI = bookmarkfaviconchangerModule.ioService.newURI(faviconDataURISpec, null, null);
				var nsIFilePicker = Components.interfaces.nsIFilePicker;
				var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
				fp.init(window, bookmarkfaviconchangerModule.bundle.GetStringFromName("exportFavicon"), nsIFilePicker.modeSave);
				fp.displayDirectory = bookmarkfaviconchangerModule.getDefaultDirectory();
				fp.appendFilter(filterTitle,filter);
				fp.appendFilters(nsIFilePicker.filterAll);
				fp.defaultString = defaultFileName + "." + defaultFileExtension;
				fp.defaultExtension = defaultFileExtension;
				try {
					var fpResult = fp.show();
				} catch(e) {
					// This is for safety, possible error from weird filename (I still cannot get this error)
					fp.defaultString = "favicon." + defaultFileExtension;
					var fpResult = fp.show();
				}
				if ((fpResult == nsIFilePicker.returnOK) || (fpResult == nsIFilePicker.returnReplace)) {
					var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
					persist.persistFlags = 24608;  // =(32 + 8192 + 16384) Ref https://developer.mozilla.org/en/XPCOM_Interface_Reference/nsIWebBrowserPersist
					if (bookmarkfaviconchangerModule.geckoBefore18) {
						persist.saveURI(faviconDataURI, null, null, null, null, fp.file);
					} else {
						// Gecko 18+ need 7th parameter for private browsing = privacyContext
						try {
							var privacyContext = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
								.getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsILoadContext);
						} catch(e) {
							var privacyContext = null;
						}
						if (bookmarkfaviconchangerModule.geckoBefore36) {
							persist.saveURI(faviconDataURI, null, null, null, null, fp.file, privacyContext);
						} else {
							// Gecko 36+ add 8th parameter between parameter 3 and 4 = refererPolicy
							// nsiHttpChannel::REFERRER_POLICY_NO_REFERRER constant = 1
							var refererPolicy = 1;
							persist.saveURI(faviconDataURI, null, null, refererPolicy, null, null, fp.file, privacyContext);
						}
					}
				}
			};
			img.src = faviconURI.spec;
		}
	},
	resetFaviconMultiple: function() {
		var selectedNodes = this.targetNodes;
		// expected no folder here because no folder can reset - so I don't need to lockCSS
		for (var i = 0; i < selectedNodes.length; i++) {
			this.targetNode = selectedNodes[i];
			this.resetFavicon();
		}
	},
	useDefaultFaviconMultiple: function() {
		var selectedNodes = this.targetNodes;
		bookmarkfaviconchangerModule.lockCSS = true;
		for (var i = 0; i < selectedNodes.length; i++) {
			this.targetNode = selectedNodes[i];
			if (PlacesUtils.nodeIsBookmark(this.targetNode)) {		// bookmark node
				this.useDefaultFavicon();
			} else {	// folder node - expect every folder has custom favicon
				this.useDefaultFaviconForFolder();
			}
		}
		bookmarkfaviconchangerModule.lockCSS = false;
		bookmarkfaviconchangerModule.changeCSS();
	},
	exportFaviconMultiple: function() {
		var selectedNodes = this.targetNodes;
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, bookmarkfaviconchangerModule.bundle.GetStringFromName("exportFavicon"), nsIFilePicker.modeSave);
		fp.displayDirectory = bookmarkfaviconchangerModule.getDefaultDirectory();
		fp.appendFilter("Zip Files (zip)","*.zip");
		fp.appendFilters(nsIFilePicker.filterAll);
		fp.defaultString = "favicon.zip";
		fp.defaultExtension = "zip";
		var fpResult = fp.show();
		if ((fpResult == nsIFilePicker.returnOK) || (fpResult == nsIFilePicker.returnReplace)) {
			var zipWriter = Components.classes["@mozilla.org/zipwriter;1"].createInstance(Components.interfaces.nsIZipWriter);
			zipWriter.open(fp.file, 0x2A);      // PR_WRITE_ONLY | PR_CREATE_FILE | PR_TRUNCATE);
			var thisTime=(new Date()).getTime();
			var fileCount = 1;
			Components.utils.import("resource://gre/modules/NetUtil.jsm");
			for (var i = 0; i < selectedNodes.length; i++) {
				if (PlacesUtils.nodeIsBookmark(selectedNodes[i])) {		// bookmark node
					try {
						var bookmarkURI = PlacesUtils.bookmarks.getBookmarkURI(selectedNodes[i].itemId);
						try {
							var faviconURI = bookmarkfaviconchangerModule.getFaviconForPage(bookmarkURI);
							var faviconDataURISpec = bookmarkfaviconchangerModule.getFaviconDataAsDataURL(bookmarkURI, faviconURI);
						} catch(e) {
							var faviconURI = bookmarkfaviconchangerModule.getFaviconImageForPage(bookmarkURI);
							var faviconDataURISpec = bookmarkfaviconchangerModule.getFaviconDataAsDataURL(bookmarkURI, faviconURI);
							if (bookmarkfaviconchangerModule.geckoBefore13) {
								// this function not return the correct URI for default livefeed item, so modified it again
								if (PlacesUtils.nodeIsLivemarkItem(selectedNodes[i])) {
									if (faviconURI.spec == bookmarkfaviconchangerModule.defaultFaviconURISpec) {
										faviconDataURISpec = bookmarkfaviconchangerModule.livemarkItemFaviconDataURISpec;
									}
								}
							}
						}
						// for safety, don't expect faviconURI as data : png because other addon may destroy it
						if (faviconDataURISpec != null) {
							var faviconDataURI = bookmarkfaviconchangerModule.ioService.newURI(faviconDataURISpec, null, null);
							var result = bookmarkfaviconchangerModule.getImageTypeFromURI(faviconDataURI,faviconDataURISpec);
							var defaultFileExtension = result[0];
							if (defaultFileExtension != "") {
								var faviconDataURIChannel = NetUtil.newChannel(faviconDataURI);
								zipWriter.addEntryChannel(fileCount+"."+defaultFileExtension, thisTime*1000, 9, faviconDataURIChannel, false);	// 9=COMPRESSION_BEST
							}
						}
					} catch(e) {
					}
				} else {	// folder node - expect every folder has custom favicon
					try {
						var folderFaviconDataURISpec = bookmarkfaviconchangerModule.annotationService.getItemAnnotation(selectedNodes[i].itemId,
							bookmarkfaviconchangerModule.itemFolderFaviconDataURISpecNS);
						var folderFaviconDataURI = bookmarkfaviconchangerModule.ioService.newURI(folderFaviconDataURISpec, null, null);
						var folderFaviconDataURIChannel = NetUtil.newChannel(folderFaviconDataURI);
						zipWriter.addEntryChannel(fileCount+".png", thisTime*1000, 9, folderFaviconDataURIChannel, false);	// 9=COMPRESSION_BEST
					} catch(e) {
					}
				}
				fileCount++;
			}
			zipWriter.close();
		}
	},
	onload: function() {
		Components.utils.import("chrome://bookmarkfaviconchanger/content/module.jsm");
		bookmarkfaviconchangerModule.init();
		Components.utils.import("resource://gre/modules/PlacesUtils.jsm");	// old name before FF4 is resource://gre/modules/utils.js
		var placesContext = document.getElementById("placesContext");
		if (placesContext) {
			placesContext.addEventListener("popupshowing", function(event){bookmarkfaviconchangerPlacesContext.popupShowing(event);}, false);
			placesContext.addEventListener("popuphiding",  function(event){bookmarkfaviconchangerPlacesContext.popupHiding(event);}, false);
			this.popupEventListening = true;
		}
		window.removeEventListener("load", function(){bookmarkfaviconchangerPlacesContext.onload();}, false);
		window.addEventListener("unload", function(){bookmarkfaviconchangerPlacesContext.onunload();}, false);
	},
	onunload: function() {
		if (this.popupEventListening) {
			var placesContext = document.getElementById("placesContext");
			placesContext.removeEventListener("popupshowing", function(event){bookmarkfaviconchangerPlacesContext.popupShowing(event);}, false);
			placesContext.removeEventListener("popuphiding",  function(event){bookmarkfaviconchangerPlacesContext.popupHiding(event);}, false);
			this.popupEventListening = false;
		}
		window.removeEventListener("unload", function(){bookmarkfaviconchangerPlacesContext.onunload();}, false);
	},
}
window.addEventListener("load", function(){bookmarkfaviconchangerPlacesContext.onload();}, false);