//================================================================
// Bookmark Favicon Changer by Sonthakit Leelahanon.
// Copyright 2016 Sonthakit Leelahanon. All rights reserved.
//================================================================

var bookmarkfaviconchangerRestore = {
	pageFaviconDataURISpecNS: "bookmarkfaviconchanger/faviconDataURISpec",	 // version >= 1.60 (not use in export and json backup, what you see is what you get policy)
	pageOriginalFaviconURISpecNS: "bookmarkfaviconchanger/faviconurispec",	 // Real NS is inherited, not good meaning, but do no change for forward compatibility
	itemFolderFaviconDataURISpecNS: "bookmarkfaviconchanger/faviconurispec", // Real NS is inherited, not good meaning, but do no change for forward compatibility
	itemJsonFolderFaviconDataURISpecNS: "bookmarkfaviconchanger/folderFaviconDataURISpec",
	itemJsonFaviconDataURISpecNS: "bookmarkfaviconchanger/faviconDataURISpec",
	itemJsonOriginalFaviconURISpecNS: "bookmarkfaviconchanger/originalFaviconURISpec",
	timerTimeout: null,
	win: null,
	titleLocale: null,
	elementMeter: null,
	elementPercent: null,
	maxProgress: null,
	meterProgress: null,
	leatestTaskPercent: 0,
	items: null,
	init: function() {
		// This chrome can be call without problem if there is no job, but should not because user may observe some dialog flash
		// Problem is I must manage asynchronous thread of setAndLoadFaviconForPage and update progress meter
		// The best option is try to set-load-destroy annotation one by one
		// The last job is for folder favicon
		// Another problem is it is not modal dialog. User can manipulate bookmark and make something fail, so use try-catch a lot
		Components.utils.import("chrome://bookmarkfaviconchanger/content/module.jsm");
		this.timerTimeout = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		this.win = document.getElementById("bookmarkfaviconchanger-restore");
		this.titleLocale = this.win.getAttribute("title");
		this.elementMeter = document.getElementById("bookmarkfaviconchangerRestoreMeter");
		this.elementPercent = document.getElementById("bookmarkfaviconchangerRestorePercent")
		this.items = bookmarkfaviconchangerModule.annotationService.getItemsWithAnnotation(this.itemJsonFaviconDataURISpecNS);
		this.maxProgress = this.items.length+1;				// one job for folder - this make maxProgress is not zero
		this.elementMeter.max = this.maxProgress;
		this.meterProgress = 0;
		this.elementMeter.value = 0;
		this.elementPercent.value = "0%";
		this.win.setAttribute("title","0% "+this.titleLocale);
		this.timerTimeout.initWithCallback({notify:function(timer){try{bookmarkfaviconchangerRestore.progress();}catch(e){}} }
			,0,Components.interfaces.nsITimer.TYPE_ONE_SHOT);			// no wait for favicon load - delay 0 millisec
	},
	progress: function() {
		this.timerTimeout.cancel();
		var waitTime = 0;				// wait time for favicon load, 0 if don't need to wait
		if (this.meterProgress < (this.maxProgress-1)) {
			var i = this.meterProgress;
			try {
				var bookmarkURI = bookmarkfaviconchangerModule.bookmarksService.getBookmarkURI(this.items[i]);
				var faviconDataURISpec = bookmarkfaviconchangerModule.annotationService.getItemAnnotation(this.items[i],this.itemJsonFaviconDataURISpecNS);
				var faviconDataURI = bookmarkfaviconchangerModule.ioService.newURI(faviconDataURISpec, null, null);
				try {
					var originalFaviconURISpec = bookmarkfaviconchangerModule.annotationService.getItemAnnotation(this.items[i]
						,this.itemJsonOriginalFaviconURISpecNS);
					bookmarkfaviconchangerModule.annotationService.setPageAnnotation(bookmarkURI,this.pageOriginalFaviconURISpecNS,originalFaviconURISpec,0,4);
					bookmarkfaviconchangerModule.annotationService.setPageAnnotation(bookmarkURI,this.pageFaviconDataURISpecNS,faviconDataURISpec,0,4);
					bookmarkfaviconchangerModule.annotationService.removeItemAnnotation(this.items[i],this.itemJsonOriginalFaviconURISpecNS);
				} catch(e) {
				}
				bookmarkfaviconchangerModule.setAndLoadFaviconForPage(bookmarkURI,faviconDataURI,true
					,function(){try{bookmarkfaviconchangerRestore.progress();}catch(e){}} );		// use try-catch if callback happen after window close
				waitTime = 10000;		// 10 second for timeout failure setAndLoadFaviconForPage
				try {
					bookmarkfaviconchangerModule.annotationService.removeItemAnnotation(this.items[i],this.itemJsonFaviconDataURISpecNS);
				} catch(e) {
				}
			} catch(e) {
			}
		} else if (this.meterProgress == (this.maxProgress-1)) {
			// Last job is to change folder favicon annotation from session expire to permanent
			var folderItems = bookmarkfaviconchangerModule.annotationService.getItemsWithAnnotation(this.itemJsonFolderFaviconDataURISpecNS);
			for (var i = 0; i < folderItems.length; i++) {
				try {
					var folderFaviconDataURISpec = bookmarkfaviconchangerModule.annotationService.getItemAnnotation(folderItems[i]
						,this.itemJsonFolderFaviconDataURISpecNS);
					bookmarkfaviconchangerModule.annotationService.setItemAnnotation(folderItems[i],this.itemFolderFaviconDataURISpecNS,folderFaviconDataURISpec,0,4);
					bookmarkfaviconchangerModule.annotationService.removeItemAnnotation(folderItems[i],this.itemJsonFolderFaviconDataURISpecNS);
				} catch(e) {
				}
			}
		} else {
			window.close();
			return;
		}
		this.meterProgress++;
		this.elementMeter.value = this.meterProgress;
		var taskPercent = Math.floor(100*this.meterProgress/this.maxProgress);
		if (this.leatestTaskPercent != taskPercent) {
			this.leatestTaskPercent = taskPercent;
			this.elementPercent.value = taskPercent +"%";
			this.win.setAttribute("title",taskPercent+"% "+this.titleLocale);
		}
		this.timerTimeout.initWithCallback({notify:function(timer){try{bookmarkfaviconchangerRestore.progress();}catch(e){}} }
			,waitTime,Components.interfaces.nsITimer.TYPE_ONE_SHOT);
	},
	userCancel: function() {
		this.timerTimeout.cancel();
		// For quick cancel,  don't destroy backup Json Annotation, they will auto removed when browser quit because they are session expire
		return true;
	}
}